package controladors;

import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import entitats.Agents;
import entitats.AgentsDao;
import entitats.Almacen;
import entitats.AlmacenDao;
import entitats.Articulos;
import entitats.ArticulosDao;
import entitats.ESTA_CARTERA_CLIENTSDao;
import entitats.Existarts;
import entitats.ExistartsDao;
import entitats.FamiliaDao;
import entitats.GrupoDao;
import entitats.LiniaPres;
import entitats.LiniaPresDao;
import entitats.LiniaPresHistorDao;
import entitats.NotFoundException;
import entitats.Numeracions;
import entitats.NumeracionsDao;
import entitats.Oferta;
import entitats.OfertaDao;
import entitats.Pressupost;
import entitats.PressupostDao;
import entitats.PressupostHistorDao;
import entitats.SubfamiliaDao;
import entitats.TESOPC;
import entitats.TESOPCDao;
import entitats.Tarifa_preciosDao;
import entitats.Visita;
import entitats.VisitaDao;
import entitats.VisitaHistorDao;
import flex.messaging.io.ArrayCollection;
import flex.messaging.io.amf.ASObject;

public class ControlGeneral {
	
	//Variable que conte la connexio a la base de dades
	Connection con = null;
    
	//Metode per establir connexio amb la base de dades
    private void conectar(){
       try{
    	 DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver()); 
         con =DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:orcl","gerard", "projecte2011");
           
       }
       catch (Exception error){
           System.out.println("Error al conectar la BD");
           System.out.println("Error: "+ error.toString());
           System.exit(-1);
           
       }
    }
   
   //Metode per tancar la connexio amb la base de dades
   private void desconectar(){
       if(con !=null){
   
        try{
              con.close();
           }
           catch(Exception e){
               System.out.println("Error al apagar la BD");
               System.out.println("Error:" +e.toString());
           }
           
       }
   }
   
   //Metode per obtenir l'agent que es logueja
   public List<String> getAgent(String usuariIn, String clauIn){
       conectar();
       AgentsDao ad = new AgentsDao();
       Agents a = new Agents();
       try {
           a = ad.getObjectUsuari(con, usuariIn, clauIn);
       } catch (SQLException ex) {
           return null;
       } catch (Exception er){
           return null;
       }
       desconectar();
       if(a == null){
    	   return null;
       }
       return a.toList();
   }
   
   //Metode per obtenir la cartera de l'agent
   public List<List<String>> getCartera(int seq_agentIn,int c) throws NotFoundException, SQLException{
	   List<List<String>> llista = new LinkedList<List<String>>();
	   conectar();
       AgentsDao ad = new AgentsDao();
       Agents a = new Agents();
       ESTA_CARTERA_CLIENTSDao ed = new ESTA_CARTERA_CLIENTSDao();
       try {
           a = ad.getObject(con, seq_agentIn);
       } catch (SQLException ex) {
           return null;
       } catch (Exception er){
           return null;
       }
       if(a == null){
    	   return null;
       }
	   llista = ed.getCartera(con,a,c);
	   desconectar();
       return llista;
   }

   //Metode per obtenir la llista de clients de l'agent
   public List<String> getClients(int seq_agentIn) throws NotFoundException, SQLException{
	   List<String> llista = new LinkedList<String>();
	   conectar();
       AgentsDao ad = new AgentsDao();
       Agents a = new Agents();
       TESOPCDao td = new TESOPCDao();
       try {
           a = ad.getObject(con, seq_agentIn);
       } catch (SQLException ex) {
           return null;
       } catch (Exception er){
           return null;
       }
       if(a == null){
    	   return null;
       }
	   llista = td.getClients(con,a);
	   desconectar();
       return llista;
   }

   //Metode per obtenir les xifres dels mesos anteriors d'un client
   public List<List<String>> getMA(int seq_agentIn, int c, String cp) throws NotFoundException, SQLException{
	   List<List<String>> llista = new LinkedList<List<String>>();
	   conectar();
       AgentsDao ad = new AgentsDao();
       Agents a = new Agents();
       TESOPCDao td = new TESOPCDao();
       TESOPC t = new TESOPC();
       ESTA_CARTERA_CLIENTSDao ed = new ESTA_CARTERA_CLIENTSDao();
       try {
    	   a = ad.getObject(con, seq_agentIn);
    	   t.setCODIGO_CP(cp);
    	   t = td.searchMatching(con, t).get(0);
       } catch (SQLException ex) {
           return null;
       } catch (Exception er){
           return null;
       }
       if(a == null){
    	   return null;
       }
       if(t == null){
    	   return null;
       }
       llista = ed.getMesosA(con, a, c, t);
	   desconectar();
       return llista;
   }

   //Metode per obtenir les xifres de l'exercici de l'any actual
   public List<List<String>> getExercici(int seq_agentIn, int cart) throws NotFoundException, SQLException{
	   List<List<String>> llista = new LinkedList<List<String>>();
	   conectar();
       AgentsDao ad = new AgentsDao();
       Agents a = new Agents();
       ESTA_CARTERA_CLIENTSDao ed = new ESTA_CARTERA_CLIENTSDao();
       try {
           a = ad.getObject(con, seq_agentIn);
       } catch (SQLException ex) {
           return null;
       } catch (Exception er){
           return null;
       }
       if(a == null){
    	   return null;
       }
	   llista = ed.getExercici(con, a, cart);
	   desconectar();
       return llista;
   }

   //Metode per obtenir un client a traves del CODIGO_CP
	public List<String> getClient(String c) {
		conectar();
	    TESOPCDao td = new TESOPCDao();
	    TESOPC t = new TESOPC();
	    try {
	    	t.setCODIGO_CP(c);
		 	t = td.searchMatching(con, t).get(0);
	    } catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    if(t == null){
	 	   return null;
	    }
		desconectar();
		return t.toList();
	}

	//Metode per obtenir un client a traves del CIF
	public List<String> getClientCif(String c) {
		conectar();
		TESOPCDao td = new TESOPCDao();
	    TESOPC t = new TESOPC();
	    try {
	 	   t.setCIF_CP(c);
	 	   t = td.searchMatching(con, t).get(0);
	    } catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    if(t == null){
	 	   return null;
	    }
		desconectar();
		return t.toList();
	}

	//Metode per obtenir el detall de les xifres de venda d'un mes concret de l'any actual
	public List<List<String>> getMT(int seq_agentIn,int c, int m) throws NotFoundException, SQLException{
		   List<List<String>> llista = new LinkedList<List<String>>();
		   conectar();
	       AgentsDao ad = new AgentsDao();
	       Agents a = new Agents();
	       ESTA_CARTERA_CLIENTSDao ed = new ESTA_CARTERA_CLIENTSDao();
	       try {
	           a = ad.getObject(con, seq_agentIn);
	       } catch (SQLException ex) {
	           return null;
	       } catch (Exception er){
	           return null;
	       }
	       if(a == null){
	    	   return null;
	       }
		   llista = ed.getMesosT(con,a,c,m);
		   desconectar();
	       return llista;
	   }

	//Metode per obtenir l'estoc d'un article que hi ha a cada magatzem
	public List<List<String>> getEstocArt(int art) throws NotFoundException, SQLException{
		   List<List<String>> llista = new LinkedList<List<String>>();
		   List<String> aux = new LinkedList<String>();
		   conectar();
		   ArticulosDao ad = new ArticulosDao();
		   Articulos a = new Articulos();
		   GrupoDao gd = new GrupoDao();
		   FamiliaDao fd = new FamiliaDao();
		   SubfamiliaDao sd = new SubfamiliaDao();
		   TESOPCDao td = new TESOPCDao();
		   Tarifa_preciosDao tpd = new Tarifa_preciosDao();
		   ExistartsDao ed = new ExistartsDao();
		   AlmacenDao ald = new AlmacenDao();
		   try {
	           a = ad.getObject(con, art);
	       } catch (SQLException ex) {
	           return null;
	       } catch (Exception er){
	           return null;
	       }
	       aux.add(a.getNombre());
	       aux.add(String.valueOf(a.getSeq_clipro()));
	       try {
	    	   aux.add(td.getObject(con, a.getSeq_clipro()).getNOMB_CP());
	       } catch (SQLException ex) {
	           return null;
	       } catch (Exception er){
	           return null;
	       }
	       try {
	    	   aux.add(String.valueOf(tpd.getObject(con, a.getSeq_articulo()).getPVP()));
	       } catch (SQLException ex) {
	           return null;
	       } catch (Exception er){
	           return null;
	       }
	       aux.add(String.valueOf(0));
	       aux.add(String.valueOf(a.getGrupo()));
	       try {
	    	   aux.add(String.valueOf(gd.getObject(con, a.getGrupo()).getDESC_GRUPO()));
	       } catch (SQLException ex) {
	           return null;
	       } catch (Exception er){
	           return null;
	       }
	       aux.add(String.valueOf(a.getFamilia()));
	       try {
	    	   aux.add(String.valueOf(fd.getObject(con, a.getFamilia()).getDESC_FAMILIA()));
	       } catch (SQLException ex) {
	           return null;
	       } catch (Exception er){
	           return null;
	       }
	       aux.add(String.valueOf(a.getSubfamilia()));
	       try {
	    	   aux.add(String.valueOf(sd.getObject(con, a.getSubfamilia()).getDESC_SUBFAMILIA()));
	       } catch (SQLException ex) {
	           return null;
	       } catch (Exception er){
	           return null;
	       }
	       llista.add(aux);
	       List<Almacen> auxAlm = new LinkedList<Almacen>();
	       auxAlm = ald.loadAll(con);
	       int i = 0;
	       while(i+1 == auxAlm.get(i).getSEQ_ALMACEN()){
	    	   Existarts e = ed.getObject(con, art, auxAlm.get(i).getSEQ_ALMACEN());
		       List<String> aux2 = new LinkedList<String>();
		       aux2.add(String.valueOf(auxAlm.get(i).getSEQ_ALMACEN()));
    		   aux2.add(auxAlm.get(i).getNOMBRE());
    		   if(e != null){
	    		   aux2.add(String.valueOf(e.getExist_act()));
	    		   aux2.add(String.valueOf(e.getV12M()));
	    		   aux2.add(a.getTipo_articulo());
	    		   aux2.add(e.getFEC_ULT_VENTA()==null? "-" : e.getFEC_ULT_VENTA().toString());
	    	   }else{
	    		   aux2.add(String.valueOf(0));
	    		   aux2.add(String.valueOf(0));
	    		   aux2.add(a.getTipo_articulo());
	    		   aux2.add(" ");
	    	   }
    		   llista.add(aux2);
    		   i++;
		   }
		   desconectar();
		   return llista;
	}

	//Metode per obtenir un article
	public List<String> getArticle(int i) {
		conectar();
		ArticulosDao ad = new ArticulosDao();
		List<String> res;
		try{
			res = ad.getObject(con,i).toList();
		} catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    desconectar();
	    return res;
	}

	//Metode per obtenir un article amb el seu preu
	public List<String> getArticlePreu(int i) {
		conectar();
		ArticulosDao ad = new ArticulosDao();
		List<String> res;
		Tarifa_preciosDao tp = new Tarifa_preciosDao();
		try{
			res = ad.getObject(con,i).toList();
			res.add(String.valueOf(tp.getObject(con, i).getPVP()));
		} catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    desconectar();
	    return res;
	}

	//Metode per obtenir les visites de l'agent, si act es cert, retorna les visites
	//a realitzar, sino, les historiques
	public List<List<String>> getVisitesAgent(int seq_agentIn,boolean act) throws NotFoundException, SQLException{
		List<List<String>> result = new LinkedList<List<String>>();
		List<Visita> llista;
		conectar();
		Visita v = new Visita();
		VisitaDao vd = new VisitaDao();
		VisitaHistorDao vhd = new VisitaHistorDao();
		v.setAGENT_V(seq_agentIn);
		if(act){
			try{
				llista = vd.searchMatching(con, v);
			} catch (SQLException ex) {
		        return null;
		    } catch (Exception er){
		        return null;
		    }
		}else{
			try{
				llista = vhd.searchMatching(con, v);
			} catch (SQLException ex) {
		        return null;
		    } catch (Exception er){
		        return null;
		    }
		}
		Iterator<Visita> i = llista.iterator();
		while(i.hasNext()){
			result.add(i.next().toList(con));
		}
		desconectar();
		return result;
	}

	//Metode per obtenir les visites d'un client, si act es cert, retorna les visites
	//a realitzar, sino, les historiques
	public List<List<String>> getVisitesClient(int seq_agentIn, String c, boolean act) throws NotFoundException, SQLException{
		List<List<String>> result = new LinkedList<List<String>>();
		List<Visita> llista;
		conectar();
		TESOPCDao td = new TESOPCDao();
	    TESOPC t = new TESOPC();
	    try {
	 	   t.setCODIGO_CP(c);
	 	   t = td.searchMatching(con, t).get(0);
	    } catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    if(t == null){
	 	   return null;
	    }
		Visita v = new Visita();
		VisitaDao vd = new VisitaDao();
		VisitaHistorDao vhd = new VisitaHistorDao();
		v.setAGENT_V(seq_agentIn);
		v.setCLIENT_V(t.getSEQ_CLIPRO());
		if(act){
			try{
				llista = vd.searchMatching(con, v);
			} catch (SQLException ex) {
		        return null;
		    } catch (Exception er){
		        return null;
		    }
		}else{
			try{
				llista = vhd.searchMatching(con, v);
			} catch (SQLException ex) {
		        return null;
		    } catch (Exception er){
		        return null;
		    }
		}
		Iterator<Visita> i = llista.iterator();
		while(i.hasNext()){
			result.add(i.next().toList(con));
		}
		desconectar();
		return result;
	}

	//Metode per guardar una visita
	public List<String> setVisita(java.util.Date d,String h,int a,String c,String coment) throws NotFoundException, SQLException{
		List<String> result = null;
		conectar();
		Visita v = new Visita();
		VisitaDao vd = new VisitaDao();
		Date date = new Date(d.getTime());
		v.setDATA_V(date);
		v.setHORA_V(h);
	 	List<Visita> lv;
		try {
		 	lv = vd.searchMatching(con, v);
	    } catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    if(lv.size() != 0) return null;
	    v.setAGENT_V(a);
	    TESOPCDao td = new TESOPCDao();
	    TESOPC t = new TESOPC();
    	t.setNOMB_COM(c);
	    try {
		 	t = td.searchMatching(con, t).get(0);
	    } catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
		v.setCLIENT_V(t.getSEQ_CLIPRO());
		v.setCOMENTARIS(coment);
		try{
			vd.create(con, v);
		} catch (SQLException ex) {
			return null;
	    } catch (Exception er){
			return null;
	    }
		result = v.toList(con);
		desconectar();
		return result;
	}

	//Metode per passar al historic una visita
	public String setVisitaH(java.util.Date d,String h,int a,String c, String coment) throws NotFoundException, SQLException, ParseException{
		String result = null;
		conectar();
		Visita v = new Visita(),v2;
		VisitaDao vd = new VisitaDao();
		VisitaHistorDao vhd = new VisitaHistorDao();
		v.setSEQ_VISITA(0);
		Date date = new Date(d.getTime());
		v.setDATA_V(date);
		v.setHORA_V(h);
		v.setAGENT_V(a);
	    TESOPCDao td = new TESOPCDao();
	    TESOPC t = new TESOPC();
	    t.setNOMB_COM(c);
	    try{
	    	t = td.searchMatching(con, t).get(0);
	    } catch (SQLException ex) {
			return ex.getLocalizedMessage();
	    } catch (Exception er){
			return er.getLocalizedMessage();
	    }
		v.setCLIENT_V(t.getSEQ_CLIPRO());
		v.setCOMENTARIS(coment);
		v2 = vd.searchMatching(con, v).get(0);
		v.setSEQ_VISITA(v2.getSEQ_VISITA());
		vhd.create(con, v2);
		vd.delete(con, v);
		desconectar();
		return result;
	}

	//Metode per obtenir un pressupost
	public List<List<String>> getPres(int a,String cp) throws NotFoundException, SQLException{
		   List<List<String>> result = new LinkedList<List<String>>();
		   conectar();
	       Pressupost p = new Pressupost();
	       p.setAGENT_P(a);
	       p.setCODI_P(cp);
	       LiniaPres l = new LiniaPres();
	       List<Pressupost> llistaP;
    	   PressupostDao pd = new PressupostDao();
	       List<LiniaPres> llistaL;
    	   try {
    		   llistaP = pd.searchMatching(con, p);
	       } catch (SQLException ex) {
	           return null;
	       } catch (Exception er){
	           return null;
	       }
	       if(llistaP.size() == 0){
	    	   PressupostHistorDao phd = new PressupostHistorDao();
	    	   try {
	    		   llistaP = phd.searchMatching(con, p);
		       } catch (SQLException ex) {
		           return null;
		       } catch (Exception er){
		           return null;
		       }
		       p = llistaP.get(0);
		       l.setSEQ_PRESSUPOST(p.getSEQ_PRESSUPOST());
		       LiniaPresHistorDao lhd = new LiniaPresHistorDao();
	    	   try {
	    		   llistaL = lhd.searchMatching(con, l);
		       } catch (SQLException ex) {
		           return null;
		       } catch (Exception er){
		           return null;
		       }
	       }else{
		       p = llistaP.get(0);
	    	   l.setSEQ_PRESSUPOST(p.getSEQ_PRESSUPOST());
		       LiniaPresDao ld = new LiniaPresDao();
	    	   try {
	    		   llistaL = ld.searchMatching(con, l);
		       } catch (SQLException ex) {
		           return null;
		       } catch (Exception er){
		           return null;
		       }
	       }
	       java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat("dd/MM/yyyy");
	       result.add(new LinkedList<String>());
		   TESOPCDao td = new TESOPCDao();
		   TESOPC t = new TESOPC();
		   t.setSEQ_CLIPRO(p.getCLIENT_P());
		   try{
		    	t = td.searchMatching(con, t).get(0);
		   } catch (SQLException ex) {
				return null;
		   } catch (Exception er){
		    	return null;
		   }
	       result.get(0).add(t.getCODIGO_CP());
	       result.get(0).add(sdf.format(p.getDATA_P()));
	       result.get(0).add(p.getESTAT());
	       result.get(0).add(p.getCOMENTARIS());
	       if(llistaL == null) System.out.println("Error!!!!!!!!!");
		   Iterator<LiniaPres> i = llistaL.iterator();
		   if(!i.hasNext()){
			   System.out.println("Error!!!!!");
		   }
		   while(i.hasNext()){
			   result.add(i.next().toList(con));
		   }
	       desconectar();
	       return result;
	   }

	//Metode per obtenir la llista de pressupostos, si op es cert, retorna les visites
	//a realitzar, sino, les historiques
	public List<String> getLlistaPres(int a,boolean op) throws NotFoundException, SQLException{
		   List<String> result = new LinkedList<String>();
		   conectar();
	       Pressupost p = new Pressupost();
	       p.setAGENT_P(a);
	       List<Pressupost> llista;
	       if(op){
	    	   PressupostDao pd = new PressupostDao();
	    	   try {
		    	   llista = pd.searchMatching(con, p);
		       } catch (SQLException ex) {
		           return null;
		       } catch (Exception er){
		           return null;
		       }
	       }else{
	    	   PressupostHistorDao pdh = new PressupostHistorDao();
	    	   try {
		    	   llista = pdh.searchMatching(con, p);
		       } catch (SQLException ex) {
		           return null;
		       } catch (Exception er){
		           return null;
		       }
	       }
	       if(llista == null){
	    	   return null;
	       }
	       desconectar();
			Iterator<Pressupost> i = llista.iterator();
			while(i.hasNext()){
				result.add(i.next().getCODI_P());
			}
	       return result;
	   }

	//Metode per obtenir la llista de pressupostos d'un client, si op es cert, retorna les visites
	//a realitzar, sino, les historiques
	public List<String> getLlistaPresClient(int a,String c,boolean op) throws NotFoundException, SQLException{
		   List<String> result = new LinkedList<String>();
		   conectar();
	       Pressupost p = new Pressupost();
	       p.setAGENT_P(a);
		   TESOPCDao td = new TESOPCDao();
		   TESOPC t = new TESOPC();
		   t.setCODIGO_CP(c);
		   try{
		    	t = td.searchMatching(con, t).get(0);
		   } catch (SQLException ex) {
	           return null;
		   } catch (Exception er){
	           return null;
		   }
		   p.setCLIENT_P(t.getSEQ_CLIPRO());
	       List<Pressupost> llista;
	       if(op){
	    	   PressupostDao pd = new PressupostDao();
	    	   try {
		    	   llista = pd.searchMatching(con, p);
		       } catch (SQLException ex) {
		           return null;
		       } catch (Exception er){
		           return null;
		       }
	       }else{
	    	   PressupostHistorDao pd = new PressupostHistorDao();
	    	   try {
		    	   llista = pd.searchMatching(con, p);
		       } catch (SQLException ex) {
		           return null;
		       } catch (Exception er){
		           return null;
		       }
	       }
	       if(llista == null){
	    	   return null;
	       }
	       desconectar();
			Iterator<Pressupost> i = llista.iterator();
			while(i.hasNext()){
				result.add(i.next().getCODI_P());
			}
	       return result;
	}

	//Metode per guardar un pressupost
	public String setPres(int a,String c,java.util.Date d,String estatP,String comentP,ArrayCollection cliPres) throws NotFoundException, SQLException, ParseException{
		String result = null;
	    if(cliPres == null) return null;
		conectar();
		Pressupost p = new Pressupost();
		PressupostDao pd = new PressupostDao();
		LiniaPres l = new LiniaPres();
		LiniaPresDao ld = new LiniaPresDao();
		Date date = new Date(d.getTime());
	    TESOPCDao td = new TESOPCDao();
	    TESOPC t = new TESOPC();
    	t.setCODIGO_CP(c);
	    try {
		 	t = td.searchMatching(con, t).get(0);
	    } catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    AlmacenDao ad = new AlmacenDao();
	    Almacen alm = new Almacen();
    	alm.setSEQ_ALMACEN(t.getSEQ_ALMACEN());
	    try {
		 	alm = ad.searchMatching(con, alm).get(0);
	    } catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
		Numeracions n = new Numeracions();
		NumeracionsDao nd = new NumeracionsDao();
	    try {
	    	n.setSERIE_A(alm.getSERIE());
		 	n = nd.searchMatching(con, n).get(0);
		 	n.setNUM_PRES(n.getNUM_PRES()+1);
	    } catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    NumberFormat f = new DecimalFormat("0000000000");
	    p.setCODI_P(n.getSERIE_A()+String.valueOf(f.format(n.getNUM_PRES())));
		p.setAGENT_P(a);
		p.setCLIENT_P(t.getSEQ_CLIPRO());
		p.setDATA_P(date);
		p.setESTAT(estatP);
		if(comentP.compareTo("") != 0) p.setCOMENTARIS(comentP);
		try{
			pd.create(con, p);
		} catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    result=p.getCODI_P();
		try{
		    nd.save(con, n);
		} catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
	    l.setSEQ_PRESSUPOST(pd.searchMatching(con, p).get(0).getSEQ_PRESSUPOST());
	    for(int i = 0;i < cliPres.size();i++){
	    	l.setLINIA_P(i+1);
	    	l.setARTICLE_L(Integer.parseInt(((ASObject) (cliPres.get(i))).get("col1").toString()));
	    	l.setUNITATS_A(Integer.parseInt(((ASObject) (cliPres.get(i))).get("col3").toString()));
	    	ld.create(con, l);
	    }
		desconectar();
		return result;
	}

	//Metode per passar a l'historic un pressupost
	public String setPresH(String cp) throws NotFoundException, SQLException, ParseException{
		String result = null;
		conectar();
		Pressupost p = new Pressupost();
		p.setCODI_P(cp);
		PressupostDao pd = new PressupostDao();
		PressupostHistorDao phd = new PressupostHistorDao();
		LiniaPres l = new LiniaPres();
		LiniaPresDao ld = new LiniaPresDao();
		LiniaPresHistorDao lhd = new LiniaPresHistorDao();
	    try {
		 	p = pd.searchMatching(con, p).get(0);
	    } catch (SQLException ex) {
	        return ex.getLocalizedMessage();
	    } catch (Exception er){
	        return er.getLocalizedMessage();
	    }
	    try{
			phd.create(con, p);
		} catch (SQLException ex) {
	        return ex.getLocalizedMessage();
	    } catch (Exception er){
	        return er.getLocalizedMessage();
	    }
	    l.setSEQ_PRESSUPOST(p.getSEQ_PRESSUPOST());
	    List<LiniaPres> llista;
	    try{
			llista = ld.searchMatching(con,l);
		} catch (SQLException ex) {
	        return ex.getLocalizedMessage();
	    } catch (Exception er){
	        return er.getLocalizedMessage();
	    }
	    for(int i = 0;i < llista.size();i++){
	    	l = llista.get(i);
		    try{
		    	ld.delete(con, l);
			} catch (SQLException ex) {
		        return ex.getLocalizedMessage();
		    } catch (Exception er){
		        return er.getLocalizedMessage();
		    }
		    try{
		    	lhd.create(con, l);
			} catch (SQLException ex) {
		        return ex.getLocalizedMessage();
		    } catch (Exception er){
		        return er.getLocalizedMessage();
		    }
	    }
	    try{
			pd.delete(con, p);
		} catch (SQLException ex) {
	        return ex.getLocalizedMessage();
	    } catch (Exception er){
	        return er.getLocalizedMessage();
	    }
		desconectar();
		return result;
	}

	//Metode per actualitzar l'estat d'un pressupost
	public String actP(String cp,String estatP){
		String result = null;
		conectar();
		Pressupost p = new Pressupost();
		PressupostDao pd = new PressupostDao();
		p.setCODI_P(cp);
		try{
		    p = pd.searchMatching(con, p).get(0);
		} catch (SQLException ex) {
			return ex.getLocalizedMessage();
	    } catch (Exception er){
			return null;
	    }
	    p.setESTAT(estatP);
		try{
		    pd.save(con, p);
		} catch (SQLException ex) {
			return ex.getLocalizedMessage();
	    } catch (Exception er){
			return null;
	    }
		desconectar();
		return result;
	}

	//Metode per obtenir les ofertes
	public List<List<String>> getOfertes() throws NotFoundException, SQLException{
		   List<List<String>> result = new LinkedList<List<String>>();
		   conectar();
	       OfertaDao od = new OfertaDao();
	       List<Oferta> llistaO;
	       try {
	    	   llistaO = od.loadAll(con);
	       } catch (SQLException ex) {
	           return null;
	       } catch (Exception er){
	           return null;
	       }
	       Iterator<Oferta> i = llistaO.iterator();
		   while(i.hasNext()){
			   result.add(i.next().toList(con));
		   }
	       desconectar();
	       return result;
	   }
}
