package entitats;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;


 /**
  * ESTA_CARTERA_CLIENTS Data Access Object (DAO).
  * This class contains all database handling that is needed to 
  * permanently store and retrieve ESTA_CARTERA_CLIENTS object instances. 
  */

 /**
  * This sourcecode has been generated by FREE DaoGen generator version 2.4.1.
  * The usage of generated code is restricted to OpenSource software projects
  * only. DaoGen is available in http://titaniclinux.net/daogen/
  * It has been programmed by Tuomo Lukka, Tuomo.Lukka@iki.fi
  *
  * DaoGen license: The following DaoGen generated source code is licensed
  * under the terms of GNU GPL license. The full text for license is available
  * in GNU project's pages: http://www.gnu.org/copyleft/gpl.html
  *
  * If you wish to use the DaoGen generator to produce code for closed-source
  * commercial applications, you must pay the lisence fee. The price is
  * 5 USD or 5 Eur for each database table, you are generating code for.
  * (That includes unlimited amount of iterations with all supported languages
  * for each database table you are paying for.) Send mail to
  * "Tuomo.Lukka@iki.fi" for more information. Thank you!
  */



public class ESTA_CARTERA_CLIENTSDao {


	/**
     * createValueObject-method. This method is used when the Dao class needs
     * to create new value object instance. The reason why this method exists
     * is that sometimes the programmer may want to extend also the valueObject
     * and then this method can be overrided to return extended valueObject.
     * NOTE: If you extend the valueObject class, make sure to override the
     * clone() method in it!
     */
    public ESTA_CARTERA_CLIENTS createValueObject() {
          return new ESTA_CARTERA_CLIENTS();
    }


    /**
     * getObject-method. This will create and load valueObject contents from database 
     * using given Primary-Key as identifier. This method is just a convenience method 
     * for the real load-method which accepts the valueObject as a parameter. Returned
     * valueObject will be created using the createValueObject() method.
     */
    public ESTA_CARTERA_CLIENTS getObject(Connection conn, int SEQ_CLIPRO, int c, int a) throws NotFoundException, SQLException {

          ESTA_CARTERA_CLIENTS valueObject = createValueObject();
          valueObject.setSEQ_CLIPRO(SEQ_CLIPRO);
          valueObject.setCARTERA(c);
          valueObject.setAGENTE(a);
          load(conn, valueObject);
          return valueObject;
    }


    /**
     * load-method. This will load valueObject contents from database using
     * Primary-Key as identifier. Upper layer should use this so that valueObject
     * instance is created and only primary-key should be specified. Then call
     * this method to complete other persistent information. This method will
     * overwrite all other fields except primary-key and possible runtime variables.
     * If load can not find matching row, NotFoundException will be thrown.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be loaded.
     *                     Primary-key field must be set for this to work properly.
     */
    public void load(Connection conn, ESTA_CARTERA_CLIENTS valueObject) throws NotFoundException, SQLException {

          String sql = "SELECT * FROM ESTA_CARTERA_CLIENTS WHERE (SEQ_CLIPRO = ? AND CARTERA = ? AND AGENTE = ?) "; 
          PreparedStatement stmt = null;

          try {
               stmt = conn.prepareStatement(sql);
               stmt.setInt(1, valueObject.getSEQ_CLIPRO()); 
               stmt.setInt(2, valueObject.getCARTERA()); 
               stmt.setInt(3, valueObject.getAGENTE()); 

               singleQuery(conn, stmt, valueObject);

          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * LoadAll-method. This will read all contents from database table and
     * build a List containing valueObjects. Please note, that this method
     * will consume huge amounts of resources if table has lot's of rows. 
     * This should only be used when target tables have only small amounts
     * of data.
     *
     * @param conn         This method requires working database connection.
     */
    public List<ESTA_CARTERA_CLIENTS> loadAll(Connection conn) throws SQLException {

          String sql = "SELECT * FROM ESTA_CARTERA_CLIENTS ORDER BY SEQ_CLIPRO ASC ";
          List<ESTA_CARTERA_CLIENTS> searchResults = listQuery(conn, conn.prepareStatement(sql));

          return searchResults;
    }



    /**
     * create-method. This will create new row in database according to supplied
     * valueObject contents. Make sure that values for all NOT NULL columns are
     * correctly specified. Also, if this table does not use automatic surrogate-keys
     * the primary-key must be specified. After INSERT command this method will 
     * read the generated primary-key back to valueObject if automatic surrogate-keys
     * were used. 
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be created.
     *                     If automatic surrogate-keys are not used the Primary-key 
     *                     field must be set for this to work properly.
     */
    public synchronized void create(Connection conn, ESTA_CARTERA_CLIENTS valueObject) throws SQLException {

          String sql = "";
          PreparedStatement stmt = null;

          try {
               sql = "INSERT INTO ESTA_CARTERA_CLIENTS ( SEQ_CLIPRO, CARTERA, AGENTE, "
               + "M1_VA, M2_VA, M3_VA, "
               + "M4_VA, M5_VA, M6_VA, "
               + "M7_VA, M8_VA, M9_VA, "
               + "M10_VA, M11_VA, M12_VA, "
               + "M1_VP, M2_VP, M3_VP, "
               + "M4_VP, M5_VP, M6_VP, "
               + "M7_VP, M8_VP, M9_VP, "
               + "M10_VP, M11_VP, M12_VP, "
               + "MES_ACTUAL, MES_ANTERIOR, DIF_MES) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?) ";
               stmt = conn.prepareStatement(sql);

               stmt.setInt(1, valueObject.getSEQ_CLIPRO()); 
               stmt.setInt(2, valueObject.getCARTERA()); 
               stmt.setInt(3, valueObject.getAGENTE()); 
               stmt.setInt(4, valueObject.getM1_VA()); 
               stmt.setInt(5, valueObject.getM2_VA()); 
               stmt.setInt(6, valueObject.getM3_VA()); 
               stmt.setInt(7, valueObject.getM4_VA()); 
               stmt.setInt(8, valueObject.getM5_VA()); 
               stmt.setInt(9, valueObject.getM6_VA()); 
               stmt.setInt(10, valueObject.getM7_VA()); 
               stmt.setInt(11, valueObject.getM8_VA()); 
               stmt.setInt(12, valueObject.getM9_VA()); 
               stmt.setInt(13, valueObject.getM10_VA()); 
               stmt.setInt(14, valueObject.getM11_VA()); 
               stmt.setInt(15, valueObject.getM12_VA()); 
               stmt.setInt(16, valueObject.getM1_VP()); 
               stmt.setInt(17, valueObject.getM2_VP()); 
               stmt.setInt(18, valueObject.getM3_VP()); 
               stmt.setInt(19, valueObject.getM4_VP()); 
               stmt.setInt(20, valueObject.getM5_VP()); 
               stmt.setInt(21, valueObject.getM6_VP()); 
               stmt.setInt(22, valueObject.getM7_VP()); 
               stmt.setInt(23, valueObject.getM8_VP()); 
               stmt.setInt(24, valueObject.getM9_VP()); 
               stmt.setInt(25, valueObject.getM10_VP()); 
               stmt.setInt(26, valueObject.getM11_VP()); 
               stmt.setInt(27, valueObject.getM12_VP()); 
               stmt.setInt(28, valueObject.getMES_ACTUAL()); 
               stmt.setInt(29, valueObject.getMES_ANTERIOR()); 
               stmt.setInt(30, valueObject.getDIF_MES()); 

               int rowcount = databaseUpdate(conn, stmt);
               if (rowcount != 1) {
                    //System.out.println("PrimaryKey Error when updating DB!");
                    throw new SQLException("PrimaryKey Error when updating DB!");
               }

          } finally {
              if (stmt != null)
                  stmt.close();
          }


    }


    /**
     * save-method. This method will save the current state of valueObject to database.
     * Save can not be used to create new instances in database, so upper layer must
     * make sure that the primary-key is correctly specified. Primary-key will indicate
     * which instance is going to be updated in database. If save can not find matching 
     * row, NotFoundException will be thrown.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be saved.
     *                     Primary-key field must be set for this to work properly.
     */
    public void save(Connection conn, ESTA_CARTERA_CLIENTS valueObject) 
          throws NotFoundException, SQLException {

          String sql = "UPDATE ESTA_CARTERA_CLIENTS SET CARTERA = ?, AGENTE = ?, M1_VA = ?, "
               + "M2_VA = ?, M3_VA = ?, M4_VA = ?, "
               + "M5_VA = ?, M6_VA = ?, M7_VA = ?, "
               + "M8_VA = ?, M9_VA = ?, M10_VA = ?, "
               + "M11_VA = ?, M12_VA = ?, M1_VP = ?, "
               + "M2_VP = ?, M3_VP = ?, M4_VP = ?, "
               + "M5_VP = ?, M6_VP = ?, M7_VP = ?, "
               + "M8_VP = ?, M9_VP = ?, M10_VP = ?, "
               + "M11_VP = ?, M12_VP = ?, MES_ACTUAL = ?, "
               + "MES_ANTERIOR = ?, DIF_MES = ? WHERE (SEQ_CLIPRO = ? ) ";
          PreparedStatement stmt = null;

          try {
              stmt = conn.prepareStatement(sql);
              stmt.setInt(1, valueObject.getCARTERA()); 
              stmt.setInt(2, valueObject.getAGENTE()); 
              stmt.setInt(3, valueObject.getM1_VA()); 
              stmt.setInt(4, valueObject.getM2_VA()); 
              stmt.setInt(5, valueObject.getM3_VA()); 
              stmt.setInt(6, valueObject.getM4_VA()); 
              stmt.setInt(7, valueObject.getM5_VA()); 
              stmt.setInt(8, valueObject.getM6_VA()); 
              stmt.setInt(9, valueObject.getM7_VA()); 
              stmt.setInt(10, valueObject.getM8_VA()); 
              stmt.setInt(11, valueObject.getM9_VA()); 
              stmt.setInt(12, valueObject.getM10_VA()); 
              stmt.setInt(13, valueObject.getM11_VA()); 
              stmt.setInt(14, valueObject.getM12_VA()); 
              stmt.setInt(15, valueObject.getM1_VP()); 
              stmt.setInt(16, valueObject.getM2_VP()); 
              stmt.setInt(17, valueObject.getM3_VP()); 
              stmt.setInt(18, valueObject.getM4_VP()); 
              stmt.setInt(19, valueObject.getM5_VP()); 
              stmt.setInt(20, valueObject.getM6_VP()); 
              stmt.setInt(21, valueObject.getM7_VP()); 
              stmt.setInt(22, valueObject.getM8_VP()); 
              stmt.setInt(23, valueObject.getM9_VP()); 
              stmt.setInt(24, valueObject.getM10_VP()); 
              stmt.setInt(25, valueObject.getM11_VP()); 
              stmt.setInt(26, valueObject.getM12_VP()); 
              stmt.setInt(27, valueObject.getMES_ACTUAL()); 
              stmt.setInt(28, valueObject.getMES_ANTERIOR()); 
              stmt.setInt(29, valueObject.getDIF_MES()); 

              stmt.setInt(30, valueObject.getSEQ_CLIPRO()); 

              int rowcount = databaseUpdate(conn, stmt);
              if (rowcount == 0) {
                   //System.out.println("Object could not be saved! (PrimaryKey not found)");
                   throw new NotFoundException("Object could not be saved! (PrimaryKey not found)");
              }
              if (rowcount > 1) {
                   //System.out.println("PrimaryKey Error when updating DB! (Many objects were affected!)");
                   throw new SQLException("PrimaryKey Error when updating DB! (Many objects were affected!)");
              }
          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * delete-method. This method will remove the information from database as identified by
     * by primary-key in supplied valueObject. Once valueObject has been deleted it can not 
     * be restored by calling save. Restoring can only be done using create method but if 
     * database is using automatic surrogate-keys, the resulting object will have different 
     * primary-key than what it was in the deleted object. If delete can not find matching row,
     * NotFoundException will be thrown.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be deleted.
     *                     Primary-key field must be set for this to work properly.
     */
    public void delete(Connection conn, ESTA_CARTERA_CLIENTS valueObject) 
          throws NotFoundException, SQLException {

          String sql = "DELETE FROM ESTA_CARTERA_CLIENTS WHERE (SEQ_CLIPRO = ? ) ";
          PreparedStatement stmt = null;

          try {
              stmt = conn.prepareStatement(sql);
              stmt.setInt(1, valueObject.getSEQ_CLIPRO()); 

              int rowcount = databaseUpdate(conn, stmt);
              if (rowcount == 0) {
                   //System.out.println("Object could not be deleted (PrimaryKey not found)");
                   throw new NotFoundException("Object could not be deleted! (PrimaryKey not found)");
              }
              if (rowcount > 1) {
                   //System.out.println("PrimaryKey Error when updating DB! (Many objects were deleted!)");
                   throw new SQLException("PrimaryKey Error when updating DB! (Many objects were deleted!)");
              }
          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * deleteAll-method. This method will remove all information from the table that matches
     * this Dao and ValueObject couple. This should be the most efficient way to clear table.
     * Once deleteAll has been called, no valueObject that has been created before can be 
     * restored by calling save. Restoring can only be done using create method but if database 
     * is using automatic surrogate-keys, the resulting object will have different primary-key 
     * than what it was in the deleted object. (Note, the implementation of this method should
     * be different with different DB backends.)
     *
     * @param conn         This method requires working database connection.
     */
    public void deleteAll(Connection conn) throws SQLException {

          String sql = "DELETE FROM ESTA_CARTERA_CLIENTS";
          PreparedStatement stmt = null;

          try {
              stmt = conn.prepareStatement(sql);
              databaseUpdate(conn, stmt);
          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * coutAll-method. This method will return the number of all rows from table that matches
     * this Dao. The implementation will simply execute "select count(primarykey) from table".
     * If table is empty, the return value is 0. This method should be used before calling
     * loadAll, to make sure table has not too many rows.
     *
     * @param conn         This method requires working database connection.
     */
    public int countAll(Connection conn) throws SQLException {

          String sql = "SELECT count(*) FROM ESTA_CARTERA_CLIENTS";
          PreparedStatement stmt = null;
          ResultSet result = null;
          int allRows = 0;

          try {
              stmt = conn.prepareStatement(sql);
              result = stmt.executeQuery();

              if (result.next())
                  allRows = result.getInt(1);
          } finally {
              if (result != null)
                  result.close();
              if (stmt != null)
                  stmt.close();
          }
          return allRows;
    }


    /** 
     * searchMatching-Method. This method provides searching capability to 
     * get matching valueObjects from database. It works by searching all 
     * objects that match permanent instance variables of given object.
     * Upper layer should use this by setting some parameters in valueObject
     * and then  call searchMatching. The result will be 0-N objects in a List, 
     * all matching those criteria you specified. Those instance-variables that
     * have NULL values are excluded in search-criteria.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance where search will be based.
     *                     Primary-key field should not be set.
     */
    public List<ESTA_CARTERA_CLIENTS> searchMatching(Connection conn, ESTA_CARTERA_CLIENTS valueObject) throws SQLException {

          List<ESTA_CARTERA_CLIENTS> searchResults;

          boolean first = true;
          StringBuffer sql = new StringBuffer("SELECT * FROM ESTA_CARTERA_CLIENTS WHERE 1=1 ");

          if (valueObject.getSEQ_CLIPRO() != 0) {
              if (first) { first = false; }
              sql.append("AND SEQ_CLIPRO = ").append(valueObject.getSEQ_CLIPRO()).append(" ");
          }

          if (valueObject.getCARTERA() != 0) {
              if (first) { first = false; }
              sql.append("AND CARTERA = ").append(valueObject.getCARTERA()).append(" ");
          }

          if (valueObject.getAGENTE() != 0) {
              if (first) { first = false; }
              sql.append("AND AGENTE = ").append(valueObject.getAGENTE()).append(" ");
          }

          if (valueObject.getM1_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M1_VA = ").append(valueObject.getM1_VA()).append(" ");
          }

          if (valueObject.getM2_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M2_VA = ").append(valueObject.getM2_VA()).append(" ");
          }

          if (valueObject.getM3_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M3_VA = ").append(valueObject.getM3_VA()).append(" ");
          }

          if (valueObject.getM4_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M4_VA = ").append(valueObject.getM4_VA()).append(" ");
          }

          if (valueObject.getM5_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M5_VA = ").append(valueObject.getM5_VA()).append(" ");
          }

          if (valueObject.getM6_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M6_VA = ").append(valueObject.getM6_VA()).append(" ");
          }

          if (valueObject.getM7_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M7_VA = ").append(valueObject.getM7_VA()).append(" ");
          }

          if (valueObject.getM8_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M8_VA = ").append(valueObject.getM8_VA()).append(" ");
          }

          if (valueObject.getM9_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M9_VA = ").append(valueObject.getM9_VA()).append(" ");
          }

          if (valueObject.getM10_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M10_VA = ").append(valueObject.getM10_VA()).append(" ");
          }

          if (valueObject.getM11_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M11_VA = ").append(valueObject.getM11_VA()).append(" ");
          }

          if (valueObject.getM12_VA() != 0) {
              if (first) { first = false; }
              sql.append("AND M12_VA = ").append(valueObject.getM12_VA()).append(" ");
          }

          if (valueObject.getM1_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M1_VP = ").append(valueObject.getM1_VP()).append(" ");
          }

          if (valueObject.getM2_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M2_VP = ").append(valueObject.getM2_VP()).append(" ");
          }

          if (valueObject.getM3_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M3_VP = ").append(valueObject.getM3_VP()).append(" ");
          }

          if (valueObject.getM4_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M4_VP = ").append(valueObject.getM4_VP()).append(" ");
          }

          if (valueObject.getM5_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M5_VP = ").append(valueObject.getM5_VP()).append(" ");
          }

          if (valueObject.getM6_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M6_VP = ").append(valueObject.getM6_VP()).append(" ");
          }

          if (valueObject.getM7_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M7_VP = ").append(valueObject.getM7_VP()).append(" ");
          }

          if (valueObject.getM8_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M8_VP = ").append(valueObject.getM8_VP()).append(" ");
          }

          if (valueObject.getM9_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M9_VP = ").append(valueObject.getM9_VP()).append(" ");
          }

          if (valueObject.getM10_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M10_VP = ").append(valueObject.getM10_VP()).append(" ");
          }

          if (valueObject.getM11_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M11_VP = ").append(valueObject.getM11_VP()).append(" ");
          }

          if (valueObject.getM12_VP() != 0) {
              if (first) { first = false; }
              sql.append("AND M12_VP = ").append(valueObject.getM12_VP()).append(" ");
          }

          if (valueObject.getMES_ACTUAL() != 0) {
              if (first) { first = false; }
              sql.append("AND MES_ACTUAL = ").append(valueObject.getMES_ACTUAL()).append(" ");
          }

          if (valueObject.getMES_ANTERIOR() != 0) {
              if (first) { first = false; }
              sql.append("AND MES_ANTERIOR = ").append(valueObject.getMES_ANTERIOR()).append(" ");
          }

          if (valueObject.getDIF_MES() != 0) {
              if (first) { first = false; }
              sql.append("AND DIF_MES = ").append(valueObject.getDIF_MES()).append(" ");
          }


          sql.append("ORDER BY SEQ_CLIPRO ASC ");

          // Prevent accidential full table results.
          // Use loadAll if all rows must be returned.
          if (first)
               searchResults = new ArrayList<ESTA_CARTERA_CLIENTS>();
          else
               searchResults = listQuery(conn, conn.prepareStatement(sql.toString()));

          return searchResults;
    }


    /** 
     * getDaogenVersion will return information about
     * generator which created these sources.
     */
    public String getDaogenVersion() {
        return "DaoGen version 2.4.1";
    }


    /**
     * databaseUpdate-method. This method is a helper method for internal use. It will execute
     * all database handling that will change the information in tables. SELECT queries will
     * not be executed here however. The return value indicates how many rows were affected.
     * This method will also make sure that if cache is used, it will reset when data changes.
     *
     * @param conn         This method requires working database connection.
     * @param stmt         This parameter contains the SQL statement to be excuted.
     */
    protected int databaseUpdate(Connection conn, PreparedStatement stmt) throws SQLException {

          int result = stmt.executeUpdate();

          return result;
    }



    /**
     * databaseQuery-method. This method is a helper method for internal use. It will execute
     * all database queries that will return only one row. The resultset will be converted
     * to valueObject. If no rows were found, NotFoundException will be thrown.
     *
     * @param conn         This method requires working database connection.
     * @param stmt         This parameter contains the SQL statement to be excuted.
     * @param valueObject  Class-instance where resulting data will be stored.
     */
    protected void singleQuery(Connection conn, PreparedStatement stmt, ESTA_CARTERA_CLIENTS valueObject) 
          throws NotFoundException, SQLException {

          ResultSet result = null;

          try {
              result = stmt.executeQuery();

              if (result.next()) {

                   valueObject.setSEQ_CLIPRO(result.getInt("SEQ_CLIPRO")); 
                   valueObject.setCARTERA(result.getInt("CARTERA")); 
                   valueObject.setAGENTE(result.getInt("AGENTE")); 
                   valueObject.setM1_VA(result.getInt("M1_VA")); 
                   valueObject.setM2_VA(result.getInt("M2_VA")); 
                   valueObject.setM3_VA(result.getInt("M3_VA")); 
                   valueObject.setM4_VA(result.getInt("M4_VA")); 
                   valueObject.setM5_VA(result.getInt("M5_VA")); 
                   valueObject.setM6_VA(result.getInt("M6_VA")); 
                   valueObject.setM7_VA(result.getInt("M7_VA")); 
                   valueObject.setM8_VA(result.getInt("M8_VA")); 
                   valueObject.setM9_VA(result.getInt("M9_VA")); 
                   valueObject.setM10_VA(result.getInt("M10_VA")); 
                   valueObject.setM11_VA(result.getInt("M11_VA")); 
                   valueObject.setM12_VA(result.getInt("M12_VA")); 
                   valueObject.setM1_VP(result.getInt("M1_VP")); 
                   valueObject.setM2_VP(result.getInt("M2_VP")); 
                   valueObject.setM3_VP(result.getInt("M3_VP")); 
                   valueObject.setM4_VP(result.getInt("M4_VP")); 
                   valueObject.setM5_VP(result.getInt("M5_VP")); 
                   valueObject.setM6_VP(result.getInt("M6_VP")); 
                   valueObject.setM7_VP(result.getInt("M7_VP")); 
                   valueObject.setM8_VP(result.getInt("M8_VP")); 
                   valueObject.setM9_VP(result.getInt("M9_VP")); 
                   valueObject.setM10_VP(result.getInt("M10_VP")); 
                   valueObject.setM11_VP(result.getInt("M11_VP")); 
                   valueObject.setM12_VP(result.getInt("M12_VP")); 
                   valueObject.setMES_ACTUAL(result.getInt("MES_ACTUAL")); 
                   valueObject.setMES_ANTERIOR(result.getInt("MES_ANTERIOR")); 
                   valueObject.setDIF_MES(result.getInt("DIF_MES")); 

              } else {
                    //System.out.println("ESTA_CARTERA_CLIENTS Object Not Found!");
                    throw new NotFoundException("ESTA_CARTERA_CLIENTS Object Not Found!");
              }
          } finally {
              if (result != null)
                  result.close();
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * databaseQuery-method. This method is a helper method for internal use. It will execute
     * all database queries that will return multiple rows. The resultset will be converted
     * to the List of valueObjects. If no rows were found, an empty List will be returned.
     *
     * @param conn         This method requires working database connection.
     * @param stmt         This parameter contains the SQL statement to be excuted.
     */
    protected List<ESTA_CARTERA_CLIENTS> listQuery(Connection conn, PreparedStatement stmt) throws SQLException {

          ArrayList<ESTA_CARTERA_CLIENTS> searchResults = new ArrayList<ESTA_CARTERA_CLIENTS>();
          ResultSet result = null;

          try {
              result = stmt.executeQuery();

              while (result.next()) {
                   ESTA_CARTERA_CLIENTS temp = createValueObject();

                   temp.setSEQ_CLIPRO(result.getInt("SEQ_CLIPRO")); 
                   temp.setCARTERA(result.getInt("CARTERA")); 
                   temp.setAGENTE(result.getInt("AGENTE")); 
                   temp.setM1_VA(result.getInt("M1_VA")); 
                   temp.setM2_VA(result.getInt("M2_VA")); 
                   temp.setM3_VA(result.getInt("M3_VA")); 
                   temp.setM4_VA(result.getInt("M4_VA")); 
                   temp.setM5_VA(result.getInt("M5_VA")); 
                   temp.setM6_VA(result.getInt("M6_VA")); 
                   temp.setM7_VA(result.getInt("M7_VA")); 
                   temp.setM8_VA(result.getInt("M8_VA")); 
                   temp.setM9_VA(result.getInt("M9_VA")); 
                   temp.setM10_VA(result.getInt("M10_VA")); 
                   temp.setM11_VA(result.getInt("M11_VA")); 
                   temp.setM12_VA(result.getInt("M12_VA")); 
                   temp.setM1_VP(result.getInt("M1_VP")); 
                   temp.setM2_VP(result.getInt("M2_VP")); 
                   temp.setM3_VP(result.getInt("M3_VP")); 
                   temp.setM4_VP(result.getInt("M4_VP")); 
                   temp.setM5_VP(result.getInt("M5_VP")); 
                   temp.setM6_VP(result.getInt("M6_VP")); 
                   temp.setM7_VP(result.getInt("M7_VP")); 
                   temp.setM8_VP(result.getInt("M8_VP")); 
                   temp.setM9_VP(result.getInt("M9_VP")); 
                   temp.setM10_VP(result.getInt("M10_VP")); 
                   temp.setM11_VP(result.getInt("M11_VP")); 
                   temp.setM12_VP(result.getInt("M12_VP")); 
                   temp.setMES_ACTUAL(result.getInt("MES_ACTUAL")); 
                   temp.setMES_ANTERIOR(result.getInt("MES_ANTERIOR")); 
                   temp.setDIF_MES(result.getInt("DIF_MES")); 

                   searchResults.add(temp);
              }

          } finally {
              if (result != null)
                  result.close();
              if (stmt != null)
                  stmt.close();
          }

          return (List<ESTA_CARTERA_CLIENTS>)searchResults;
    }

    //Metode per obtenir la cartera de l'agent 
	public List<List<String>> getCartera(Connection conn, Agents a, int c) throws NotFoundException, SQLException {
		List<List<String>> llista = new LinkedList<List<String>>();
		ESTA_CARTERA_CLIENTS valueObject = createValueObject();
        valueObject.setCARTERA(c);
        valueObject.setAGENTE(a.getSeq_agent());
        String sql = "SELECT * FROM GWA_ESTA_CARTERA_CLIENTS WHERE (CARTERA = ? AND AGENTE = ? ) "; 
        PreparedStatement stmt = null;

        try {
             stmt = conn.prepareStatement(sql);
             stmt.setInt(1, valueObject.getCARTERA()); 
             stmt.setInt(2, valueObject.getAGENTE()); 

             llista = carteraAgent(conn, stmt);

        } finally {
            if (stmt != null)
                stmt.close();
        }
		return llista;
	}

    //Metode per obtenir les dades de la cartera de la base de dades
    private List<List<String>> carteraAgent(Connection conn, PreparedStatement stmt) throws SQLException, NotFoundException {
    	
    	List<List<String>> llista = new LinkedList<List<String>>();
        ResultSet result = null;

        try {
            result = stmt.executeQuery();

            while (result.next()) {
            	List<String> temp = new LinkedList<String>();

                 try{
                	 TESOPCDao td = new TESOPCDao();
                	 temp.add(String.valueOf(td.getObject(conn, result.getInt("SEQ_CLIPRO")).getCODIGO_CP()));
                	 temp.add(String.valueOf(td.getObject(conn, result.getInt("SEQ_CLIPRO")).getNOMB_CP()));
                 }catch(Error e){
                	 return null;
                 }
                 temp.add(String.valueOf(result.getInt("MES_ACTUAL"))); 
                 temp.add(String.valueOf(result.getInt("MES_ANTERIOR"))); 
                 temp.add(String.valueOf(result.getInt("DIF_MES")));
                 temp.add(String.valueOf(result.getInt("M1_VA")));
                 llista.add(temp);
            }

        } finally {
            if (result != null)
                result.close();
            if (stmt != null)
                stmt.close();
        }

        return llista;
	}

    //Metode per obtenir els mesos anteriors d'un client
	public List<List<String>> getMesosA(Connection conn, Agents a, int c, TESOPC client) throws NotFoundException, SQLException {
		List<List<String>> llista = new LinkedList<List<String>>();
		ESTA_CARTERA_CLIENTS valueObject = createValueObject();
        valueObject.setCARTERA(c);
        valueObject.setAGENTE(a.getSeq_agent());
        valueObject.setSEQ_CLIPRO(client.getSEQ_CLIPRO());
        String sql = "SELECT * FROM GWA_ESTA_CARTERA_CLIENTS WHERE (CARTERA = ? AND AGENTE = ? AND SEQ_CLIPRO = ?)"; 
        PreparedStatement stmt = null;

        try {
             stmt = conn.prepareStatement(sql);
             stmt.setInt(1, valueObject.getCARTERA()); 
             stmt.setInt(2, valueObject.getAGENTE());  
             stmt.setInt(3, valueObject.getSEQ_CLIPRO()); 

             llista = carteraMA(conn, stmt);

        } finally {
            if (stmt != null)
                stmt.close();
        }
		return llista;
	}

    //Metode per obtenir les dades dels mesos anteriors de la base de dades
    @SuppressWarnings("deprecation")
	private List<List<String>> carteraMA(Connection conn, PreparedStatement stmt) throws SQLException, NotFoundException {
    	
    	List<List<String>> llista = new LinkedList<List<String>>();
        ResultSet result = null;
    	Date d = new Date(System.currentTimeMillis());
        int m = d.getMonth();
        int a = d.getYear()+1900;
        try {
            result = stmt.executeQuery();

            if (result.next()) {
            	List<String> temp = new LinkedList<String>();
            	 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
	           	 temp.add(String.valueOf(m));
	             temp.add(String.valueOf(result.getInt("M12_VA")));
	        	 temp.add(String.valueOf(m));
	             temp.add(String.valueOf(result.getInt("M12_VP")));
	        	 temp.add(String.valueOf(a));
	             if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M11_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M11_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
	        	 temp.add(String.valueOf(result.getInt("M10_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M10_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
	        	 temp.add(String.valueOf(result.getInt("M9_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M9_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
	        	 temp.add(String.valueOf(result.getInt("M8_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M8_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
	        	 temp.add(String.valueOf(result.getInt("M7_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M7_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
	        	 temp.add(String.valueOf(result.getInt("M6_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M6_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
	        	 temp.add(String.valueOf(result.getInt("M5_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M5_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
	        	 temp.add(String.valueOf(result.getInt("M4_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M4_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
	        	 temp.add(String.valueOf(result.getInt("M3_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M3_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
	        	 temp.add(String.valueOf(result.getInt("M2_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M2_VP")));
	        	 temp.add(String.valueOf(a));
                 if(m == 0){
            		 m=11;
            		 a--;
            	 }else{
            		 m--;
            	 }
                 llista.add(temp);
                 temp = new LinkedList<String>();
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M1_VA")));
	        	 temp.add(String.valueOf(m));
                 temp.add(String.valueOf(result.getInt("M1_VP")));
	        	 temp.add(String.valueOf(a));
                 llista.add(temp);
            }

        } finally {
            if (result != null)
                result.close();
            if (stmt != null)
                stmt.close();
        }

        return llista;
	}

    //Metode per obtenir els mesos tancats
	public List<List<String>> getMesosT(Connection conn, Agents a, int c, int m) throws NotFoundException, SQLException {
		List<List<String>> llista = new LinkedList<List<String>>();
		ESTA_CARTERA_CLIENTS valueObject = createValueObject();
        valueObject.setCARTERA(c);
        valueObject.setAGENTE(a.getSeq_agent());
        String sql = "SELECT * FROM GWA_ESTA_CARTERA_CLIENTS WHERE (CARTERA = ? AND AGENTE = ?) "; 
        PreparedStatement stmt = null;

        try {
             stmt = conn.prepareStatement(sql);
             stmt.setInt(1, valueObject.getCARTERA()); 
             stmt.setInt(2, valueObject.getAGENTE()); 

             llista = carteraMT(conn, stmt, a, c, m);

        } finally {
            if (stmt != null)
                stmt.close();
        }
		return llista;
	}

    //Metode per obtenir les dades dels mesos tancats de la base de dades
    private List<List<String>> carteraMT(Connection conn, PreparedStatement stmt, Agents a, int c, int m) throws SQLException, NotFoundException {
    	
    	List<List<String>> llista = new LinkedList<List<String>>();
        ResultSet result = null;
        int difM;
        @SuppressWarnings("deprecation")
		int mesAct=Calendar.getInstance().getTime().getMonth();
        String mesA,mesP,sum1="",sum2="";
        if(m>mesAct){
        	difM = 12-m+mesAct;
        }else{
        	difM = mesAct-m;
        }
        switch(difM){
	    	case 0:	mesA = "M1_VA";
					mesP = "M1_VP";
					break;
	    	case 1:	mesA = "M12_VA";
					mesP = "M12_VP";
					break;
	    	case 2:	mesA = "M11_VA";
					mesP = "M11_VP";
					break;
	    	case 3:	mesA = "M10_VA";
					mesP = "M10_VP";
					break;
	    	case 4:	mesA = "M9_VA";
					mesP = "M9_VP";
					break;
	    	case 5:	mesA = "M8_VA";
					mesP = "M8_VP";
					break;
	    	case 6:	mesA = "M7_VA";
					mesP = "M7_VP";
					break;
	    	case 7:	mesA = "M6_VA";
					mesP = "M6_VP";
					break;
	    	case 8:	mesA = "M5_VA";
					mesP = "M5_VP";
					break;
	    	case 9: mesA = "M4_VA";
					mesP = "M4_VP";
					break;
	    	case 10:mesA = "M3_VA";
					mesP = "M3_VP";
					break;
			default:mesA = "M2_VA";
					mesP = "M2_VP";
					break;
        }
        int i = 1;
		if(mesAct!=0) i = 13-mesAct;
        int j = 0;
        while(j <= m){
        	if(j!=0){
        		sum1+="+";
        		sum2+="+";
        	}
        	sum1 = sum1 + "M" + i + "_VA";
        	sum2 = sum2 + "M" + i + "_VP";
        	i++;
        	j++;
        }
        try {
            result = stmt.executeQuery();

            while (result.next()) {
            	List<String> temp = new LinkedList<String>();
           	 	TESOPCDao td = new TESOPCDao();

                 try{
                	 temp.add(String.valueOf(td.getObject(conn, result.getInt("SEQ_CLIPRO")).getCODIGO_CP()));
                	 temp.add(String.valueOf(td.getObject(conn, result.getInt("SEQ_CLIPRO")).getNOMB_CP()));
                 }catch(Error e){
                	 return null;
                 }
                 temp.add(String.valueOf(result.getInt(mesA)));
                 temp.add(String.valueOf(result.getInt(mesP)));
                 temp.add(String.valueOf(comptaMT(conn, a, c, td.getObject(conn, result.getInt("SEQ_CLIPRO")), sum1)));
                 temp.add(String.valueOf(comptaMT(conn, a, c, td.getObject(conn, result.getInt("SEQ_CLIPRO")), sum2)));
                 llista.add(temp);
            }

        } finally {
            if (result != null)
                result.close();
            if (stmt != null)
                stmt.close();
        }

        return llista;
	}

    //Metode per obtenir la suma de l'acumulat
	private int comptaMT(Connection conn, Agents a, int c, TESOPC client, String m) throws NotFoundException, SQLException {
		int res=0;
		ResultSet result;
		ESTA_CARTERA_CLIENTS valueObject = createValueObject();
        valueObject.setCARTERA(c);
        valueObject.setAGENTE(a.getSeq_agent());
        valueObject.setSEQ_CLIPRO(client.getSEQ_CLIPRO());
        String sql = "SELECT "+m+" FROM GWA_ESTA_CARTERA_CLIENTS WHERE (CARTERA = ? AND AGENTE = ? AND SEQ_CLIPRO = ?) "; 
        PreparedStatement stmt = null;

        try {
             stmt = conn.prepareStatement(sql);
             stmt.setInt(1, valueObject.getCARTERA()); 
             stmt.setInt(2, valueObject.getAGENTE());
             stmt.setInt(3, valueObject.getSEQ_CLIPRO());
             result = stmt.executeQuery();
             while(result.next()){
            	 res = res + result.getInt(1);
             }
        } finally {
            if (stmt != null)
                stmt.close();
        }
		return res;
	}

    //Metode per obtenir les xifres de l'exercici de l'any actual
	public List<List<String>> getExercici(Connection conn, Agents a, int cart) throws NotFoundException, SQLException {
		List<List<String>> llista = new LinkedList<List<String>>();
		ESTA_CARTERA_CLIENTS valueObject = createValueObject();
        valueObject.setAGENTE(a.getSeq_agent());
        String sql = "SELECT SUM(M12_VA) AS \"1\", SUM(M11_VA) AS \"2\", SUM(M10_VA) AS \"3\", SUM(M9_VA) AS \"4\"" +
        		", SUM(M8_VA) AS \"5\", SUM(M7_VA) AS \"6\", SUM(M6_VA) AS \"7\", SUM(M5_VA) AS \"8\", SUM(M4_VA) AS \"9\"" +
        		", SUM(M3_VA) AS \"10\", SUM(M2_VA) AS \"11\", SUM(M1_VA) AS \"12\", SUM(M12_VP) AS \"13\", SUM(M11_VP) AS \"14\"" +
        		", SUM(M10_VP) AS \"15\", SUM(M9_VP) AS \"16\", SUM(M8_VP) AS \"17\", SUM(M7_VP) AS \"18\", SUM(M6_VP) AS \"19\"" +
        		", SUM(M5_VP) AS \"20\", SUM(M4_VP) AS \"21\", SUM(M3_VP) AS \"22\", SUM(M2_VP) AS \"23\", SUM(M1_VP) AS \"24\"" +
        		" FROM GWA_ESTA_CARTERA_CLIENTS WHERE AGENTE = ? AND CARTERA = ?"; 
        PreparedStatement stmt = null;

        try {
             stmt = conn.prepareStatement(sql);
             stmt.setInt(1, valueObject.getAGENTE());
             stmt.setInt(2, cart);

             llista = carteraExercici(conn, stmt);

        } finally {
            if (stmt != null)
                stmt.close();
        }
		return llista;
	}

    //Metode per obtenir les dades de l'exercici de la base de dades
    @SuppressWarnings("deprecation")
	private List<List<String>> carteraExercici(Connection conn, PreparedStatement stmt) throws SQLException, NotFoundException {
    	
    	List<List<String>> llista = new LinkedList<List<String>>();
        ResultSet result = null;

        try {
            result = stmt.executeQuery();

            if (result.next()) {
            	Date d = new Date(System.currentTimeMillis());
            	int i= 12+d.getMonth();
            	for(int j = 0;j<12;j++){
            		List<String> temp = new LinkedList<String>();
                	if(i-12 <= 0){
	            		 temp.add("0"); 
		                 temp.add(String.valueOf(result.getInt(String.valueOf(i))));
            		 }else{
	            		 temp.add(String.valueOf(result.getInt(String.valueOf(i-12)))); 
		                 temp.add(String.valueOf(result.getInt(String.valueOf(i))));
            		 }
            		 i--;
	                 llista.add(temp);
            	}
            }

        } finally {
            if (result != null)
                result.close();
            if (stmt != null)
                stmt.close();
        }

        return llista;
	}
}
