package entitats;

import java.io.Serializable;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;

 /**
  * LiniaPres Value Object.
  * This class is value object representing database table GWA_LINIA_P
  * This class is intented to be used together with associated Dao object.
  */

 /**
  * This sourcecode has been generated by FREE DaoGen generator version 2.4.1.
  * The usage of generated code is restricted to OpenSource software projects
  * only. DaoGen is available in http://titaniclinux.net/daogen/
  * It has been programmed by Tuomo Lukka, Tuomo.Lukka@iki.fi
  *
  * DaoGen license: The following DaoGen generated source code is licensed
  * under the terms of GNU GPL license. The full text for license is available
  * in GNU project's pages: http://www.gnu.org/copyleft/gpl.html
  *
  * If you wish to use the DaoGen generator to produce code for closed-source
  * commercial applications, you must pay the lisence fee. The price is
  * 5 USD or 5 Eur for each database table, you are generating code for.
  * (That includes unlimited amount of iterations with all supported languages
  * for each database table you are paying for.) Send mail to
  * "Tuomo.Lukka@iki.fi" for more information. Thank you!
  */



public class LiniaPres implements Cloneable, Serializable {

    private static final long serialVersionUID = 1L;
	/** 
     * Persistent Instance variables. This data is directly 
     * mapped to the columns of database table.
     */
    private int SEQ_PRESSUPOST;
    private int LINIA_P;
    private int ARTICLE_L;
    private int UNITATS_A;



    /** 
     * Constructors. DaoGen generates two constructors by default.
     * The first one takes no arguments and provides the most simple
     * way to create object instance. The another one takes one
     * argument, which is the primary key of the corresponding table.
     */

    public LiniaPres () {

    }

    public LiniaPres (int SEQ_PRESSUPOSTIn, int LINIA_PIn) {

          this.SEQ_PRESSUPOST = SEQ_PRESSUPOSTIn;
          this.LINIA_P = LINIA_PIn;

    }


    /** 
     * Get- and Set-methods for persistent variables. The default
     * behaviour does not make any checks against malformed data,
     * so these might require some manual additions.
     */

    public int getSEQ_PRESSUPOST() {
          return this.SEQ_PRESSUPOST;
    }
    public void setSEQ_PRESSUPOST(int SEQ_PRESSUPOSTIn) {
          this.SEQ_PRESSUPOST = SEQ_PRESSUPOSTIn;
    }

    public int getLINIA_P() {
          return this.LINIA_P;
    }
    public void setLINIA_P(int LINIA_PIn) {
          this.LINIA_P = LINIA_PIn;
    }

    public int getARTICLE_L() {
          return this.ARTICLE_L;
    }
    public void setARTICLE_L(int ARTICLE_LIn) {
          this.ARTICLE_L = ARTICLE_LIn;
    }

    public int getUNITATS_A() {
          return this.UNITATS_A;
    }
    public void setUNITATS_A(int UNITATS_AIn) {
          this.UNITATS_A = UNITATS_AIn;
    }



    /** 
     * setAll allows to set all persistent variables in one method call.
     * This is useful, when all data is available and it is needed to 
     * set the initial state of this object. Note that this method will
     * directly modify instance variales, without going trough the 
     * individual set-methods.
     */

    public void setAll(int SEQ_PRESSUPOSTIn,
          int LINIA_PIn,
          int ARTICLE_LIn,
          int UNITATS_AIn) {
          this.SEQ_PRESSUPOST = SEQ_PRESSUPOSTIn;
          this.LINIA_P = LINIA_PIn;
          this.ARTICLE_L = ARTICLE_LIn;
          this.UNITATS_A = UNITATS_AIn;
    }


    /** 
     * hasEqualMapping-method will compare two LiniaPres instances
     * and return true if they contain same values in all persistent instance 
     * variables. If hasEqualMapping returns true, it does not mean the objects
     * are the same instance. However it does mean that in that moment, they 
     * are mapped to the same row in database.
     */
    public boolean hasEqualMapping(LiniaPres valueObject) {

          if (valueObject.getSEQ_PRESSUPOST() != this.SEQ_PRESSUPOST) {
                    return(false);
          }
          if (valueObject.getLINIA_P() != this.LINIA_P) {
                    return(false);
          }
          if (valueObject.getARTICLE_L() != this.ARTICLE_L) {
                    return(false);
          }
          if (valueObject.getUNITATS_A() != this.UNITATS_A) {
                    return(false);
          }

          return true;
    }



    /**
     * toString will return String object representing the state of this 
     * valueObject. This is useful during application development, and 
     * possibly when application is writing object states in textlog.
     */
    public String toString() {
        StringBuffer out = new StringBuffer(this.getDaogenVersion());
        out.append("\nclass LiniaPres, mapping to table GWA_LINIA_P\n");
        out.append("Persistent attributes: \n"); 
        out.append("SEQ_PRESSUPOST = " + this.SEQ_PRESSUPOST + "\n"); 
        out.append("LINIA_P = " + this.LINIA_P + "\n"); 
        out.append("ARTICLE_L = " + this.ARTICLE_L + "\n"); 
        out.append("UNITATS_A = " + this.UNITATS_A + "\n"); 
        return out.toString();
    }

	//Metode per transformar l'objecte en una llista d'strings
	public List<String> toList(Connection con) {
		List<String> l = new LinkedList<String>();
		Articulos a = new Articulos();
		ArticulosDao ad = new ArticulosDao();
 	    try {
		   a = ad.getObject(con, ARTICLE_L);
        } catch (SQLException ex) {
           return null;
        } catch (Exception er){
           return null;
        }
        if(a == null) return null;
		l.add(String.valueOf(a.getSeq_articulo()));
		l.add(a.getNombre());
		l.add(String.valueOf(UNITATS_A));
		Tarifa_preciosDao tp = new Tarifa_preciosDao();
		try{
			l.add(String.valueOf(tp.getObject(con, ARTICLE_L).getPVP()));
		} catch (SQLException ex) {
	        return null;
	    } catch (Exception er){
	        return null;
	    }
		return l;
	}


    /**
     * Clone will return identical deep copy of this valueObject.
     * Note, that this method is different than the clone() which
     * is defined in java.lang.Object. Here, the retuned cloned object
     * will also have all its attributes cloned.
     */
    public Object clone() {
        LiniaPres cloned = new LiniaPres();

        cloned.setSEQ_PRESSUPOST(this.SEQ_PRESSUPOST); 
        cloned.setLINIA_P(this.LINIA_P); 
        cloned.setARTICLE_L(this.ARTICLE_L); 
        cloned.setUNITATS_A(this.UNITATS_A); 
        return cloned;
    }



    /** 
     * getDaogenVersion will return information about
     * generator which created these sources.
     */
    public String getDaogenVersion() {
        return "DaoGen version 2.4.1";
    }

}
