package entitats;

import java.sql.*;
import java.util.*;


 /**
  * GWA_TESOPC Data Access Object (DAO).
  * This class contains all database handling that is needed to 
  * permanently store and retrieve GWA_TESOPC object instances. 
  */

 /**
  * This sourcecode has been generated by FREE DaoGen generator version 2.4.1.
  * The usage of generated code is restricted to OpenSource software projects
  * only. DaoGen is available in http://titaniclinux.net/daogen/
  * It has been programmed by Tuomo Lukka, Tuomo.Lukka@iki.fi
  *
  * DaoGen license: The following DaoGen generated source code is licensed
  * under the terms of GNU GPL license. The full text for license is available
  * in GNU project's pages: http://www.gnu.org/copyleft/gpl.html
  *
  * If you wish to use the DaoGen generator to produce code for closed-source
  * commercial applications, you must pay the lisence fee. The price is
  * 5 USD or 5 Eur for each database table, you are generating code for.
  * (That includes unlimited amount of iterations with all supported languages
  * for each database table you are paying for.) Send mail to
  * "Tuomo.Lukka@iki.fi" for more information. Thank you!
  */



public class TESOPCDao {



    /**
     * createValueObject-method. This method is used when the Dao class needs
     * to create new value object instance. The reason why this method exists
     * is that sometimes the programmer may want to extend also the valueObject
     * and then this method can be overrided to return extended valueObject.
     * NOTE: If you extend the valueObject class, make sure to override the
     * clone() method in it!
     */
    public TESOPC createValueObject() {
          return new TESOPC();
    }


    /**
     * getObject-method. This will create and load valueObject contents from database 
     * using given Primary-Key as identifier. This method is just a convenience method 
     * for the real load-method which accepts the valueObject as a parameter. Returned
     * valueObject will be created using the createValueObject() method.
     */
    public TESOPC getObject(Connection conn, int SEQ_CLIPRO) throws NotFoundException, SQLException {

        TESOPC valueObject = createValueObject();
        valueObject.setSEQ_CLIPRO(SEQ_CLIPRO);
        load(conn, valueObject);
        return valueObject;
    }

    //Metode per obtenir la llista de clients de l'agent
	public List<String> getClients(Connection con, Agents a) throws SQLException {
		List<String> llista = new LinkedList<String>();
		TESOPC valueObject = createValueObject();
        valueObject.setAGET_SEQ_REPRESEN(a.getSeq_agent());
        String sql = "SELECT * FROM GWA_TESOPC WHERE ( AGET_SEQ_REPRESEN = ? ) "; 
        PreparedStatement stmt = null;

        try {
             stmt = con.prepareStatement(sql);
             stmt.setInt(1, valueObject.getAGET_SEQ_REPRESEN()); 

             llista = llistaNoms(con, stmt);

        } finally {
            if (stmt != null)
                stmt.close();
        }
		return llista;
	}

    //Metode per obtenir els noms per a la llista de clients de l'agent
    private List<String> llistaNoms(Connection con, PreparedStatement stmt) throws SQLException {
    	List<String> llista = new LinkedList<String>();
        ResultSet result = null;

        try {
            result = stmt.executeQuery();

            while (result.next()) {
            	llista.add(result.getString("NOMB_COM"));
            }

        } finally {
            if (result != null)
                result.close();
            if (stmt != null)
                stmt.close();
        }

        return llista;
	}


	/**
     * load-method. This will load valueObject contents from database using
     * Primary-Key as identifier. Upper layer should use this so that valueObject
     * instance is created and only primary-key should be specified. Then call
     * this method to complete other persistent information. This method will
     * overwrite all other fields except primary-key and possible runtime variables.
     * If load can not find matching row, NotFoundException will be thrown.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be loaded.
     *                     Primary-key field must be set for this to work properly.
     */
    public void load(Connection conn, TESOPC valueObject) throws NotFoundException, SQLException {

          String sql = "SELECT * FROM GWA_TESOPC WHERE (SEQ_CLIPRO = ? ) "; 
          PreparedStatement stmt = null;

          try {
               stmt = conn.prepareStatement(sql);
               stmt.setInt(1, valueObject.getSEQ_CLIPRO()); 

               singleQuery(conn, stmt, valueObject);

          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * LoadAll-method. This will read all contents from database table and
     * build a List containing valueObjects. Please note, that this method
     * will consume huge amounts of resources if table has lot's of rows. 
     * This should only be used when target tables have only small amounts
     * of data.
     *
     * @param conn         This method requires working database connection.
     */
    public List<TESOPC> loadAll(Connection conn) throws SQLException {

          String sql = "SELECT * FROM GWA_TESOPC ORDER BY SEQ_CLIPRO ASC ";
          List<TESOPC> searchResults = listQuery(conn, conn.prepareStatement(sql));

          return searchResults;
    }



    /**
     * create-method. This will create new row in database according to supplied
     * valueObject contents. Make sure that values for all NOT NULL columns are
     * correctly specified. Also, if this table does not use automatic surrogate-keys
     * the primary-key must be specified. After INSERT command this method will 
     * read the generated primary-key back to valueObject if automatic surrogate-keys
     * were used. 
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be created.
     *                     If automatic surrogate-keys are not used the Primary-key 
     *                     field must be set for this to work properly.
     */
    public synchronized void create(Connection conn, TESOPC valueObject) throws SQLException {

          String sql = "";
          PreparedStatement stmt = null;

          try {
               sql = "INSERT INTO GWA_TESOPC ( SEQ_CLIPRO, AGET_SEQ_REPRESEN, FORP_FOR_PAG, "
               + "TIPOC_TIPO_CLI, IND_CP, CODIGO_CP, "
               + "NOMB_CP, NOMB_COM, DOMI_CP, "
               + "LOCA_CP, CIF_CP, COD_POSTAL, "
               + "COD_PAIS, TELEF_CP, FAX_CP, "
               + "REFEREN, FEC_ALTA, TIPO_FAC, "
               + "DCTO_PP, EMAIL, IND_BLOQ, "
               + "OBSERVA, TELEFONO2, MOVIL, "
               + "SEQ_ALMACEN) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?) ";
               stmt = conn.prepareStatement(sql);

               stmt.setInt(1, valueObject.getSEQ_CLIPRO()); 
               stmt.setInt(2, valueObject.getAGET_SEQ_REPRESEN()); 
               stmt.setInt(3, valueObject.getFORP_FOR_PAG()); 
               stmt.setString(4, valueObject.getTIPOC_TIPO_CLI()); 
               stmt.setString(5, valueObject.getIND_CP()); 
               stmt.setString(6, valueObject.getCODIGO_CP()); 
               stmt.setString(7, valueObject.getNOMB_CP()); 
               stmt.setString(8, valueObject.getNOMB_COM()); 
               stmt.setString(9, valueObject.getDOMI_CP()); 
               stmt.setString(10, valueObject.getLOCA_CP()); 
               stmt.setString(11, valueObject.getCIF_CP()); 
               stmt.setInt(12, valueObject.getCOD_POSTAL()); 
               stmt.setInt(13, valueObject.getCOD_PAIS()); 
               stmt.setString(14, valueObject.getTELEF_CP()); 
               stmt.setString(15, valueObject.getFAX_CP()); 
               stmt.setString(16, valueObject.getREFEREN()); 
               stmt.setDate(17, valueObject.getFEC_ALTA()); 
               stmt.setString(18, valueObject.getTIPO_FAC()); 
               stmt.setInt(19, valueObject.getDCTO_PP()); 
               stmt.setString(20, valueObject.getEMAIL()); 
               stmt.setString(21, valueObject.getIND_BLOQ()); 
               stmt.setString(22, valueObject.getOBSERVA()); 
               stmt.setString(23, valueObject.getTELEFONO2()); 
               stmt.setString(24, valueObject.getMOVIL()); 
               stmt.setInt(25, valueObject.getSEQ_ALMACEN()); 

               int rowcount = databaseUpdate(conn, stmt);
               if (rowcount != 1) {
                    //System.out.println("PrimaryKey Error when updating DB!");
                    throw new SQLException("PrimaryKey Error when updating DB!");
               }

          } finally {
              if (stmt != null)
                  stmt.close();
          }


    }


    /**
     * save-method. This method will save the current state of valueObject to database.
     * Save can not be used to create new instances in database, so upper layer must
     * make sure that the primary-key is correctly specified. Primary-key will indicate
     * which instance is going to be updated in database. If save can not find matching 
     * row, NotFoundException will be thrown.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be saved.
     *                     Primary-key field must be set for this to work properly.
     */
    public void save(Connection conn, TESOPC valueObject) 
          throws NotFoundException, SQLException {

          String sql = "UPDATE GWA_TESOPC SET AGET_SEQ_REPRESEN = ?, FORP_FOR_PAG = ?, TIPOC_TIPO_CLI = ?, "
               + "IND_CP = ?, CODIGO_CP = ?, NOMB_CP = ?, "
               + "NOMB_COM = ?, DOMI_CP = ?, LOCA_CP = ?, "
               + "CIF_CP = ?, COD_POSTAL = ?, COD_PAIS = ?, "
               + "TELEF_CP = ?, FAX_CP = ?, REFEREN = ?, "
               + "FEC_ALTA = ?, TIPO_FAC = ?, DCTO_PP = ?, "
               + "EMAIL = ?, IND_BLOQ = ?, OBSERVA = ?, "
               + "TELEFONO2 = ?, MOVIL = ?, SEQ_ALMACEN = ? WHERE (SEQ_CLIPRO = ? ) ";
          PreparedStatement stmt = null;

          try {
              stmt = conn.prepareStatement(sql);
              stmt.setInt(1, valueObject.getAGET_SEQ_REPRESEN()); 
              stmt.setInt(2, valueObject.getFORP_FOR_PAG()); 
              stmt.setString(3, valueObject.getTIPOC_TIPO_CLI()); 
              stmt.setString(4, valueObject.getIND_CP()); 
              stmt.setString(5, valueObject.getCODIGO_CP()); 
              stmt.setString(6, valueObject.getNOMB_CP()); 
              stmt.setString(7, valueObject.getNOMB_COM()); 
              stmt.setString(8, valueObject.getDOMI_CP()); 
              stmt.setString(9, valueObject.getLOCA_CP()); 
              stmt.setString(10, valueObject.getCIF_CP()); 
              stmt.setInt(11, valueObject.getCOD_POSTAL()); 
              stmt.setInt(12, valueObject.getCOD_PAIS()); 
              stmt.setString(13, valueObject.getTELEF_CP()); 
              stmt.setString(14, valueObject.getFAX_CP()); 
              stmt.setString(15, valueObject.getREFEREN()); 
              stmt.setDate(16, valueObject.getFEC_ALTA()); 
              stmt.setString(17, valueObject.getTIPO_FAC()); 
              stmt.setInt(18, valueObject.getDCTO_PP()); 
              stmt.setString(19, valueObject.getEMAIL()); 
              stmt.setString(20, valueObject.getIND_BLOQ()); 
              stmt.setString(21, valueObject.getOBSERVA()); 
              stmt.setString(22, valueObject.getTELEFONO2()); 
              stmt.setString(23, valueObject.getMOVIL()); 
              stmt.setInt(24, valueObject.getSEQ_ALMACEN()); 

              stmt.setInt(25, valueObject.getSEQ_CLIPRO()); 

              int rowcount = databaseUpdate(conn, stmt);
              if (rowcount == 0) {
                   //System.out.println("Object could not be saved! (PrimaryKey not found)");
                   throw new NotFoundException("Object could not be saved! (PrimaryKey not found)");
              }
              if (rowcount > 1) {
                   //System.out.println("PrimaryKey Error when updating DB! (Many objects were affected!)");
                   throw new SQLException("PrimaryKey Error when updating DB! (Many objects were affected!)");
              }
          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * delete-method. This method will remove the information from database as identified by
     * by primary-key in supplied valueObject. Once valueObject has been deleted it can not 
     * be restored by calling save. Restoring can only be done using create method but if 
     * database is using automatic surrogate-keys, the resulting object will have different 
     * primary-key than what it was in the deleted object. If delete can not find matching row,
     * NotFoundException will be thrown.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be deleted.
     *                     Primary-key field must be set for this to work properly.
     */
    public void delete(Connection conn, TESOPC valueObject) 
          throws NotFoundException, SQLException {

          String sql = "DELETE FROM GWA_TESOPC WHERE (SEQ_CLIPRO = ? ) ";
          PreparedStatement stmt = null;

          try {
              stmt = conn.prepareStatement(sql);
              stmt.setInt(1, valueObject.getSEQ_CLIPRO()); 

              int rowcount = databaseUpdate(conn, stmt);
              if (rowcount == 0) {
                   //System.out.println("Object could not be deleted (PrimaryKey not found)");
                   throw new NotFoundException("Object could not be deleted! (PrimaryKey not found)");
              }
              if (rowcount > 1) {
                   //System.out.println("PrimaryKey Error when updating DB! (Many objects were deleted!)");
                   throw new SQLException("PrimaryKey Error when updating DB! (Many objects were deleted!)");
              }
          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * deleteAll-method. This method will remove all information from the table that matches
     * this Dao and ValueObject couple. This should be the most efficient way to clear table.
     * Once deleteAll has been called, no valueObject that has been created before can be 
     * restored by calling save. Restoring can only be done using create method but if database 
     * is using automatic surrogate-keys, the resulting object will have different primary-key 
     * than what it was in the deleted object. (Note, the implementation of this method should
     * be different with different DB backends.)
     *
     * @param conn         This method requires working database connection.
     */
    public void deleteAll(Connection conn) throws SQLException {

          String sql = "DELETE FROM GWA_TESOPC";
          PreparedStatement stmt = null;

          try {
              stmt = conn.prepareStatement(sql);
              databaseUpdate(conn, stmt);
          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * coutAll-method. This method will return the number of all rows from table that matches
     * this Dao. The implementation will simply execute "select count(primarykey) from table".
     * If table is empty, the return value is 0. This method should be used before calling
     * loadAll, to make sure table has not too many rows.
     *
     * @param conn         This method requires working database connection.
     */
    public int countAll(Connection conn) throws SQLException {

          String sql = "SELECT count(*) FROM GWA_TESOPC";
          PreparedStatement stmt = null;
          ResultSet result = null;
          int allRows = 0;

          try {
              stmt = conn.prepareStatement(sql);
              result = stmt.executeQuery();

              if (result.next())
                  allRows = result.getInt(1);
          } finally {
              if (result != null)
                  result.close();
              if (stmt != null)
                  stmt.close();
          }
          return allRows;
    }


    /** 
     * searchMatching-Method. This method provides searching capability to 
     * get matching valueObjects from database. It works by searching all 
     * objects that match permanent instance variables of given object.
     * Upper layer should use this by setting some parameters in valueObject
     * and then  call searchMatching. The result will be 0-N objects in a List, 
     * all matching those criteria you specified. Those instance-variables that
     * have NULL values are excluded in search-criteria.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance where search will be based.
     *                     Primary-key field should not be set.
     */
    public List<TESOPC> searchMatching(Connection conn, TESOPC valueObject) throws SQLException {

          List<TESOPC> searchResults;

          boolean first = true;
          StringBuffer sql = new StringBuffer("SELECT * FROM GWA_TESOPC WHERE 1=1 ");

          if (valueObject.getSEQ_CLIPRO() != 0) {
              if (first) { first = false; }
              sql.append("AND SEQ_CLIPRO = ").append(valueObject.getSEQ_CLIPRO()).append(" ");
          }

          if (valueObject.getAGET_SEQ_REPRESEN() != 0) {
              if (first) { first = false; }
              sql.append("AND AGET_SEQ_REPRESEN = ").append(valueObject.getAGET_SEQ_REPRESEN()).append(" ");
          }

          if (valueObject.getFORP_FOR_PAG() != 0) {
              if (first) { first = false; }
              sql.append("AND FORP_FOR_PAG = ").append(valueObject.getFORP_FOR_PAG()).append(" ");
          }

          if (valueObject.getTIPOC_TIPO_CLI() != null) {
              if (first) { first = false; }
              sql.append("AND TIPOC_TIPO_CLI LIKE '").append(valueObject.getTIPOC_TIPO_CLI()).append("%' ");
          }

          if (valueObject.getIND_CP() != null) {
              if (first) { first = false; }
              sql.append("AND IND_CP LIKE '").append(valueObject.getIND_CP()).append("%' ");
          }

          if (valueObject.getCODIGO_CP() != null) {
              if (first) { first = false; }
              sql.append("AND CODIGO_CP LIKE '").append(valueObject.getCODIGO_CP()).append("%' ");
          }

          if (valueObject.getNOMB_CP() != null) {
              if (first) { first = false; }
              sql.append("AND NOMB_CP LIKE '").append(valueObject.getNOMB_CP()).append("%' ");
          }

          if (valueObject.getNOMB_COM() != null) {
              if (first) { first = false; }
              sql.append("AND NOMB_COM LIKE '").append(valueObject.getNOMB_COM()).append("%' ");
          }

          if (valueObject.getDOMI_CP() != null) {
              if (first) { first = false; }
              sql.append("AND DOMI_CP LIKE '").append(valueObject.getDOMI_CP()).append("%' ");
          }

          if (valueObject.getLOCA_CP() != null) {
              if (first) { first = false; }
              sql.append("AND LOCA_CP LIKE '").append(valueObject.getLOCA_CP()).append("%' ");
          }

          if (valueObject.getCIF_CP() != null) {
              if (first) { first = false; }
              sql.append("AND CIF_CP LIKE '").append(valueObject.getCIF_CP()).append("%' ");
          }

          if (valueObject.getCOD_POSTAL() != 0) {
              if (first) { first = false; }
              sql.append("AND COD_POSTAL = ").append(valueObject.getCOD_POSTAL()).append(" ");
          }

          if (valueObject.getCOD_PAIS() != 0) {
              if (first) { first = false; }
              sql.append("AND COD_PAIS = ").append(valueObject.getCOD_PAIS()).append(" ");
          }

          if (valueObject.getTELEF_CP() != null) {
              if (first) { first = false; }
              sql.append("AND TELEF_CP LIKE '").append(valueObject.getTELEF_CP()).append("%' ");
          }

          if (valueObject.getFAX_CP() != null) {
              if (first) { first = false; }
              sql.append("AND FAX_CP LIKE '").append(valueObject.getFAX_CP()).append("%' ");
          }

          if (valueObject.getREFEREN() != null) {
              if (first) { first = false; }
              sql.append("AND REFEREN LIKE '").append(valueObject.getREFEREN()).append("%' ");
          }

          if (valueObject.getFEC_ALTA() != null) {
              if (first) { first = false; }
              sql.append("AND FEC_ALTA = '").append(valueObject.getFEC_ALTA()).append("' ");
          }

          if (valueObject.getTIPO_FAC() != null) {
              if (first) { first = false; }
              sql.append("AND TIPO_FAC LIKE '").append(valueObject.getTIPO_FAC()).append("%' ");
          }

          if (valueObject.getDCTO_PP() != 0) {
              if (first) { first = false; }
              sql.append("AND DCTO_PP = ").append(valueObject.getDCTO_PP()).append(" ");
          }

          if (valueObject.getEMAIL() != null) {
              if (first) { first = false; }
              sql.append("AND EMAIL LIKE '").append(valueObject.getEMAIL()).append("%' ");
          }

          if (valueObject.getIND_BLOQ() != null) {
              if (first) { first = false; }
              sql.append("AND IND_BLOQ LIKE '").append(valueObject.getIND_BLOQ()).append("%' ");
          }

          if (valueObject.getOBSERVA() != null) {
              if (first) { first = false; }
              sql.append("AND OBSERVA LIKE '").append(valueObject.getOBSERVA()).append("%' ");
          }

          if (valueObject.getTELEFONO2() != null) {
              if (first) { first = false; }
              sql.append("AND TELEFONO2 LIKE '").append(valueObject.getTELEFONO2()).append("%' ");
          }

          if (valueObject.getMOVIL() != null) {
              if (first) { first = false; }
              sql.append("AND MOVIL LIKE '").append(valueObject.getMOVIL()).append("%' ");
          }

          if (valueObject.getSEQ_ALMACEN() != 0) {
              if (first) { first = false; }
              sql.append("AND SEQ_ALMACEN = ").append(valueObject.getSEQ_ALMACEN()).append(" ");
          }


          sql.append("ORDER BY SEQ_CLIPRO ASC ");

          // Prevent accidential full table results.
          // Use loadAll if all rows must be returned.
          if (first)
               searchResults = new ArrayList<TESOPC>();
          else
               searchResults = listQuery(conn, conn.prepareStatement(sql.toString()));

          return searchResults;
    }


    /** 
     * getDaogenVersion will return information about
     * generator which created these sources.
     */
    public String getDaogenVersion() {
        return "DaoGen version 2.4.1";
    }


    /**
     * databaseUpdate-method. This method is a helper method for internal use. It will execute
     * all database handling that will change the information in tables. SELECT queries will
     * not be executed here however. The return value indicates how many rows were affected.
     * This method will also make sure that if cache is used, it will reset when data changes.
     *
     * @param conn         This method requires working database connection.
     * @param stmt         This parameter contains the SQL statement to be excuted.
     */
    protected int databaseUpdate(Connection conn, PreparedStatement stmt) throws SQLException {

          int result = stmt.executeUpdate();

          return result;
    }



    /**
     * databaseQuery-method. This method is a helper method for internal use. It will execute
     * all database queries that will return only one row. The resultset will be converted
     * to valueObject. If no rows were found, NotFoundException will be thrown.
     *
     * @param conn         This method requires working database connection.
     * @param stmt         This parameter contains the SQL statement to be excuted.
     * @param valueObject  Class-instance where resulting data will be stored.
     */
    protected void singleQuery(Connection conn, PreparedStatement stmt, TESOPC valueObject) 
          throws NotFoundException, SQLException {

          ResultSet result = null;

          try {
              result = stmt.executeQuery();

              if (result.next()) {

                   valueObject.setSEQ_CLIPRO(result.getInt("SEQ_CLIPRO")); 
                   valueObject.setAGET_SEQ_REPRESEN(result.getInt("AGET_SEQ_REPRESEN")); 
                   valueObject.setFORP_FOR_PAG(result.getInt("FORP_FOR_PAG")); 
                   valueObject.setTIPOC_TIPO_CLI(result.getString("TIPOC_TIPO_CLI")); 
                   valueObject.setIND_CP(result.getString("IND_CP")); 
                   valueObject.setCODIGO_CP(result.getString("CODIGO_CP")); 
                   valueObject.setNOMB_CP(result.getString("NOMB_CP")); 
                   valueObject.setNOMB_COM(result.getString("NOMB_COM")); 
                   valueObject.setDOMI_CP(result.getString("DOMI_CP")); 
                   valueObject.setLOCA_CP(result.getString("LOCA_CP")); 
                   valueObject.setCIF_CP(result.getString("CIF_CP")); 
                   valueObject.setCOD_POSTAL(result.getInt("COD_POSTAL")); 
                   valueObject.setCOD_PAIS(result.getInt("COD_PAIS")); 
                   valueObject.setTELEF_CP(result.getString("TELEF_CP")); 
                   valueObject.setFAX_CP(result.getString("FAX_CP")); 
                   valueObject.setREFEREN(result.getString("REFEREN")); 
                   valueObject.setFEC_ALTA(result.getDate("FEC_ALTA")); 
                   valueObject.setTIPO_FAC(result.getString("TIPO_FAC")); 
                   valueObject.setDCTO_PP(result.getInt("DCTO_PP")); 
                   valueObject.setEMAIL(result.getString("EMAIL")); 
                   valueObject.setIND_BLOQ(result.getString("IND_BLOQ")); 
                   valueObject.setOBSERVA(result.getString("OBSERVA")); 
                   valueObject.setTELEFONO2(result.getString("TELEFONO2")); 
                   valueObject.setMOVIL(result.getString("MOVIL")); 
                   valueObject.setSEQ_ALMACEN(result.getInt("SEQ_ALMACEN")); 

              } else {
                    //System.out.println("GWA_TESOPC Object Not Found!");
                    throw new NotFoundException("GWA_TESOPC Object Not Found!");
              }
          } finally {
              if (result != null)
                  result.close();
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * databaseQuery-method. This method is a helper method for internal use. It will execute
     * all database queries that will return multiple rows. The resultset will be converted
     * to the List of valueObjects. If no rows were found, an empty List will be returned.
     *
     * @param conn         This method requires working database connection.
     * @param stmt         This parameter contains the SQL statement to be excuted.
     */
    protected List<TESOPC> listQuery(Connection conn, PreparedStatement stmt) throws SQLException {

          ArrayList<TESOPC> searchResults = new ArrayList<TESOPC>();
          ResultSet result = null;

          try {
              result = stmt.executeQuery();

              while (result.next()) {
                   TESOPC temp = createValueObject();

                   temp.setSEQ_CLIPRO(result.getInt("SEQ_CLIPRO")); 
                   temp.setAGET_SEQ_REPRESEN(result.getInt("AGET_SEQ_REPRESEN")); 
                   temp.setFORP_FOR_PAG(result.getInt("FORP_FOR_PAG")); 
                   temp.setTIPOC_TIPO_CLI(result.getString("TIPOC_TIPO_CLI")); 
                   temp.setIND_CP(result.getString("IND_CP")); 
                   temp.setCODIGO_CP(result.getString("CODIGO_CP")); 
                   temp.setNOMB_CP(result.getString("NOMB_CP")); 
                   temp.setNOMB_COM(result.getString("NOMB_COM")); 
                   temp.setDOMI_CP(result.getString("DOMI_CP")); 
                   temp.setLOCA_CP(result.getString("LOCA_CP")); 
                   temp.setCIF_CP(result.getString("CIF_CP")); 
                   temp.setCOD_POSTAL(result.getInt("COD_POSTAL")); 
                   temp.setCOD_PAIS(result.getInt("COD_PAIS")); 
                   temp.setTELEF_CP(result.getString("TELEF_CP")); 
                   temp.setFAX_CP(result.getString("FAX_CP")); 
                   temp.setREFEREN(result.getString("REFEREN")); 
                   temp.setFEC_ALTA(result.getDate("FEC_ALTA")); 
                   temp.setTIPO_FAC(result.getString("TIPO_FAC")); 
                   temp.setDCTO_PP(result.getInt("DCTO_PP")); 
                   temp.setEMAIL(result.getString("EMAIL")); 
                   temp.setIND_BLOQ(result.getString("IND_BLOQ")); 
                   temp.setOBSERVA(result.getString("OBSERVA")); 
                   temp.setTELEFONO2(result.getString("TELEFONO2")); 
                   temp.setMOVIL(result.getString("MOVIL")); 
                   temp.setSEQ_ALMACEN(result.getInt("SEQ_ALMACEN")); 

                   searchResults.add(temp);
              }

          } finally {
              if (result != null)
                  result.close();
              if (stmt != null)
                  stmt.close();
          }

          return (List<TESOPC>)searchResults;
    }


}
