DROP TABLE GWA_NUMERACIONS;
DROP SEQUENCE numV;
DROP TABLE GWA_VISITA;
DROP TABLE GWA_VISITA_HISTOR;
DROP TABLE GWA_LINIA_P;
DROP TABLE GWA_LINIA_P_HISTOR;
DROP SEQUENCE numP;
DROP TABLE GWA_PRESSUPOST;
DROP TABLE GWA_PRESSUPOST_HISTOR;
DROP TABLE GWA_TARIFA_PRECIOS;
DROP TABLE GWA_EXISTARTS;
DROP TABLE GWA_ESTA_CARTERA_CLIENTS;
DROP TABLE GWA_ARTICULOS;
DROP TABLE GWA_SUBFAMILIAS;
DROP TABLE GWA_FAMILIAS;
DROP TABLE GWA_GRUPOS;
DROP TABLE GWA_TESOPC;
DROP TABLE GWA_ALMACENES;
DROP TABLE GWA_ESTABLECIMIENTOS;
DROP TABLE GWA_TIPOCLIS;
DROP TABLE GWA_AGENTS;

SET DEFINE OFF;

@C:/PFC/BdD/GWA_AGENTS.sql;

@C:/PFC/BdD/GWA_TIPOCLIS.sql;

@C:/PFC/BdD/GWA_ALMACENES.sql;

CREATE TABLE GWA_VISITA (
SEQ_VISITA		NUMBER(9) primary key NOT NULL,
DATA_V			DATE NOT NULL,
HORA_V 			VARCHAR2(5) NOT NULL,
AGENT_V			NUMBER(9) NOT NULL,
CLIENT_V		NUMBER(9) NOT NULL,
COMENTARIS		VARCHAR2(100));

create sequence numV
START WITH 1
INCREMENT BY 1;

alter table GWA_VISITA
add constraint FK_VISITA_AGENT
foreign key (AGENT_V)
references GWA_AGENTS(SEQ_AGENT);

alter table GWA_VISITA
add constraint FK_VISITA_CLIENT
foreign key (CLIENT_V)
references GWA_TESOPC(SEQ_CLIPRO);

CREATE TABLE GWA_VISITA_HISTOR (
SEQ_VISITA		NUMBER(9) primary key NOT NULL,
DATA_V			DATE NOT NULL,
HORA_V 			VARCHAR2(5) NOT NULL,
AGENT_V			NUMBER(9) NOT NULL,
CLIENT_V		NUMBER(9) NOT NULL,
COMENTARIS		VARCHAR2(100));

alter table GWA_VISITA_HISTOR
add constraint FK_VISITA_HISTOR_AGENT
foreign key (AGENT_V)
references GWA_AGENTS(SEQ_AGENT);

alter table GWA_VISITA_HISTOR
add constraint FK_VISITA_HISTOR_CLIENT
foreign key (CLIENT_V)
references GWA_TESOPC(SEQ_CLIPRO);

@C:/PFC/BdD/GWA_NUMERACIONS.sql;

CREATE TABLE GWA_PRESSUPOST (
SEQ_PRESSUPOST		NUMBER(9) primary key NOT NULL,
CODI_P			VARCHAR2(12) NOT NULL,
AGENT_P			NUMBER(9) NOT NULL,
CLIENT_P		NUMBER(9) NOT NULL,
DATA_P			DATE NOT NULL,
ESTAT			VARCHAR2(1) NOT NULL,
COMENTARIS		VARCHAR2(150));

create sequence numP
START WITH 1
INCREMENT BY 1;

alter table GWA_PRESSUPOST
add constraint FK_PRESSUPOST_AGENT
foreign key (AGENT_P)
references GWA_AGENTS(SEQ_AGENT);

alter table GWA_PRESSUPOST
add constraint FK_PRESSUPOST_CLIENT
foreign key (CLIENT_P)
references GWA_TESOPC(SEQ_CLIPRO);

CREATE TABLE GWA_PRESSUPOST_HISTOR (
SEQ_PRESSUPOST		NUMBER(9) primary key NOT NULL,
CODI_P			VARCHAR2(12) NOT NULL,
AGENT_P			NUMBER(9) NOT NULL,
CLIENT_P		NUMBER(9) NOT NULL,
DATA_P			DATE NOT NULL,
ESTAT			VARCHAR2(1) NOT NULL,
COMENTARIS		VARCHAR2(150));

alter table GWA_PRESSUPOST_HISTOR
add constraint FK_PRESSUPOST_HISTOR_AGENT
foreign key (AGENT_P)
references GWA_AGENTS(SEQ_AGENT);

alter table GWA_PRESSUPOST_HISTOR
add constraint FK_PRESSUPOST_HISTOR_CLIENT
foreign key (CLIENT_P)
references GWA_TESOPC(SEQ_CLIPRO);

CREATE TABLE GWA_LINIA_P (
      SEQ_PRESSUPOST NUMBER(9) NOT NULL,
      LINIA_P NUMBER(5) NOT NULL,
      ARTICLE_L NUMBER(9),
      UNITATS_A NUMBER(5),
PRIMARY KEY(SEQ_PRESSUPOST, LINIA_P));

alter table GWA_LINIA_P
add constraint FK_LINIA_PRESSUPOST
foreign key (SEQ_PRESSUPOST)
references GWA_PRESSUPOST(SEQ_PRESSUPOST);

alter table GWA_LINIA_P
add constraint FK_LINIA_ARTICLE
foreign key (ARTICLE_L)
references GWA_ARTICULOS(SEQ_ARTICULO);

CREATE TABLE GWA_LINIA_P_HISTOR (
      SEQ_PRESSUPOST NUMBER(9) NOT NULL,
      LINIA_P NUMBER(5) NOT NULL,
      ARTICLE_L NUMBER(9),
      UNITATS_A NUMBER(5),
PRIMARY KEY(SEQ_PRESSUPOST, LINIA_P));

alter table GWA_LINIA_P_HISTOR
add constraint FK_LINIA_HISTOR_PRESSUPOST
foreign key (SEQ_PRESSUPOST)
references GWA_PRESSUPOST_HISTOR(SEQ_PRESSUPOST);

alter table GWA_LINIA_P_HISTOR
add constraint FK_LINIA_HISTOR_ARTICLE
foreign key (ARTICLE_L)
references GWA_ARTICULOS(SEQ_ARTICULO);

@C:/PFC/BdD/GWA_TESOPC.sql;

@C:/PFC/BdD/GWA_GRUPOS.sql;

@C:/PFC/BdD/GWA_FAMILIAS.sql;

@C:/PFC/BdD/GWA_SUBFAMILIAS.sql;

@C:/PFC/BdD/GWA_ARTICULOS.sql;

@C:/PFC/BdD/GWA_ESTA_CARTERA_CLIENTS.sql;

@C:/PFC/BdD/GWA_TARIFA_PRECIOS.sql;

@C:/PFC/BdD/GWA_OFERTA.sql;

@C:/PFC/BdD/GWA_EXISTARTS.sql;

COMMIT;
